<?php
require_once(dirname(__FILE__).'/constants.php');
require_once(dirname(__FILE__).'/database.php');
require_once(dirname(__FILE__).'/session.php');


class Process {
	function Process() {
		global $session, $logger;

		if(!isset($_REQUEST['request_name'])) $_REQUEST['request_name'] = '';

		if ( isset($_REQUEST['proclogin']) ) $this->proclogin();
		elseif ( isset($_REQUEST['procregistration']) ) $this->procregistration();
		elseif( $_REQUEST['request_name'] == 'execute_command' ) $this->proc_execute_command();
		
		elseif( $_REQUEST['request_name'] == 'get_db_options' ) $this->proc_get_db_options();
		elseif( $_REQUEST['request_name'] == 'save_db_options' ) $this->proc_save_db_options();
		elseif( $_REQUEST['request_name'] == 'get_sip_ip_transport' ) $this->proc_get_sip_ip_transport();
		elseif( $_REQUEST['request_name'] == 'save_sip_ip_transport' ) $this->proc_save_sip_ip_transport();
		elseif( $_REQUEST['request_name'] == 'del_sip_ip_transport' ) $this->proc_del_sip_ip_transport();
		elseif( $_REQUEST['request_name'] == 'get_sip_accounts' ) $this->proc_get_sip_accounts();
		elseif( $_REQUEST['request_name'] == 'get_sip_accounts_basepage' ) $this->proc_get_sip_accounts_basepage();
		elseif( $_REQUEST['request_name'] == 'get_sip_account_types' ) $this->proc_get_sip_account_types();
		elseif( $_REQUEST['request_name'] == 'save_sip_account' ) $this->proc_save_sip_account();
		elseif( $_REQUEST['request_name'] == 'del_sip_account' ) $this->proc_del_sip_account();
		elseif( $_REQUEST['request_name'] == 'get_active_sessions' ) $this->proc_get_active_sessions();
		elseif( $_REQUEST['request_name'] == 'get_archive_sessions' ) $this->proc_get_archive_sessions();
		elseif( $_REQUEST['request_name'] == 'get_dialplans' ) $this->proc_get_dialplans();
		elseif( $_REQUEST['request_name'] == 'get_dialpattern' ) $this->proc_get_dialpattern();
		elseif( $_REQUEST['request_name'] == 'get_dialtarget' ) $this->proc_get_dialtarget();
		elseif( $_REQUEST['request_name'] == 'get_step_method' ) $this->proc_get_step_method();
		//elseif( $_REQUEST['request_name'] == 'save_sip_account' ) $this->proc_save_sip_account();
		//elseif( $_REQUEST['request_name'] == 'del_sip_account' ) $this->proc_del_sip_account();
		elseif( $_REQUEST['request_name'] == 'save_dialplan' ) $this->proc_save_dialplan();
		elseif( $_REQUEST['request_name'] == 'del_dialplan' ) $this->proc_del_dialplan();
		elseif( $_REQUEST['request_name'] == 'save_dialpattern' ) $this->proc_save_dialpattern();
		elseif( $_REQUEST['request_name'] == 'del_dialpattern' ) $this->proc_del_dialpattern();
		elseif( $_REQUEST['request_name'] == 'get_sip_accounts_filterpage' ) $this->proc_get_sip_accounts_filterpage();
		elseif( $_REQUEST['request_name'] == 'save_dialtarget' ) $this->proc_save_dialtarget();
		elseif( $_REQUEST['request_name'] == 'del_dialtarget' ) $this->proc_del_dialtarget();
		elseif( $_REQUEST['request_name'] == 'get_dialplan_filterpage' ) $this->proc_get_dialplan_filterpage();

		elseif( $_REQUEST['request_name'] == 'get_media_server' ) $this->proc_get_media_server();
		elseif( $_REQUEST['request_name'] == 'save_media_server' ) $this->proc_save_media_server();
		elseif( $_REQUEST['request_name'] == 'del_media_server' ) $this->proc_del_media_server();
		elseif( $_REQUEST['request_name'] == 'get_sip_controller' ) $this->proc_get_sip_controller();
		elseif( $_REQUEST['request_name'] == 'save_sip_controller' ) $this->proc_save_sip_controller();
		elseif( $_REQUEST['request_name'] == 'del_sip_controller' ) $this->proc_del_sip_controller();
		elseif( $_REQUEST['request_name'] == 'get_sip_controller_server' ) $this->proc_get_sip_controller_server();
		elseif( $_REQUEST['request_name'] == 'save_sip_controller_server' ) $this->proc_save_sip_controller_server();
		elseif( $_REQUEST['request_name'] == 'del_sip_controller_server' ) $this->proc_del_sip_controller_server();
		elseif( $_REQUEST['request_name'] == 'check_sip_account_name' ) $this->proc_check_sip_account_name();

		// opensips start
		elseif( $_REQUEST['request_name'] == 'get_domain' ) $this->proc_get_domain();
		elseif( $_REQUEST['request_name'] == 'save_domain' ) $this->proc_save_domain();
		elseif( $_REQUEST['request_name'] == 'get_subscriber_page' ) $this->proc_get_subscriber_page();
		elseif( $_REQUEST['request_name'] == 'save_subscriber' ) $this->proc_save_subscriber();
		elseif( $_REQUEST['request_name'] == 'del_subscriber' ) $this->proc_del_subscriber();
		elseif( $_REQUEST['request_name'] == 'get_user_location' ) $this->proc_get_user_location();

		elseif( $_REQUEST['request_name'] == 'get_registrant_page' ) $this->proc_get_registrant_page();
		elseif( $_REQUEST['request_name'] == 'save_registrant' ) $this->proc_save_registrant();
		elseif( $_REQUEST['request_name'] == 'del_registrant' ) $this->proc_del_registrant();

		elseif( $_REQUEST['request_name'] == 'get_gateway_page' ) $this->proc_get_gateway_page();
		elseif( $_REQUEST['request_name'] == 'get_gateway_set' ) $this->proc_get_gateway_set();
		elseif( $_REQUEST['request_name'] == 'save_gateway' ) $this->proc_save_gateway();
		elseif( $_REQUEST['request_name'] == 'del_gateway' ) $this->proc_del_gateway();

		elseif( $_REQUEST['request_name'] == 'get_cdr_acc_page' ) $this->proc_get_cdr_acc_page();
		elseif( $_REQUEST['request_name'] == 'get_cdr_mc_page' ) $this->proc_get_cdr_mc_page();

		elseif( $_REQUEST['request_name'] == 'get_gwrule_page' ) $this->proc_get_gwrule_page();
		elseif( $_REQUEST['request_name'] == 'save_rule' ) $this->proc_save_rule();
		elseif( $_REQUEST['request_name'] == 'del_rule' ) $this->proc_del_rule();

		elseif( $_REQUEST['request_name'] == 'get_select_gateway_page' ) $this->proc_get_select_gateway_page();

		elseif( $_REQUEST['request_name'] == 'get_user' ) $this->proc_get_user();
		elseif( $_REQUEST['request_name'] == 'save_user' ) $this->proc_save_user();
		elseif( $_REQUEST['request_name'] == 'del_user' ) $this->proc_del_user();

		elseif( $_REQUEST['request_name'] == 'opensips_reg_reload' ) $this->proc_opensips_reg_reload();
		elseif( $_REQUEST['request_name'] == 'opensips_dr_reload' ) $this->proc_opensips_dr_reload();
		elseif( $_REQUEST['request_name'] == 'opensips_dr_gw_status' ) $this->proc_opensips_dr_gw_status();


		elseif( $_REQUEST['request_name'] == 'gateways_new_prefix' ) $this->proc_gateways_new_prefix();

		elseif( $_REQUEST['request_name'] == 'get_rule_type' ) $this->proc_get_rule_type();


		
		elseif($session->logged_in)
			$this->proclogout();
		else
			header("Location: ../main.php");
		

	}

	// логин
	function proclogin() {
		//global $session, $database, $form, $logger;
		global $session, $database, $logger;
		//$logger->log("procLogin:post=".print_r($session->syssession, true));
		
		$txt_login = $_REQUEST['txt_login'];
		$txt_password = $_REQUEST['txt_password'];
		$txt_remember = 0;

		$res = $session->login($txt_login, $txt_password, $txt_remember);

		/*
		if($res){
			// log data about success authorization
			$database->logOfficeChange(CL_OF_UAC_LOGIN, $session->of_id, 0, "Успешная авторизация. Пользователь '".$session->user_name."' (id:".$session->user_id.")");
			$logger->log("process:login = success, user = {$_REQUEST['txt_login']}");
		} else {
			// log data about authorization error
			$database->logOfficeChange(CL_OF_UAC_LOGIN_FAIL, -1, 0, "Неуспешная попытка авторизации под пользователем '{$_REQUEST['txt_login']}'.");
			$logger->log("process:login = failed, user = {$_REQUEST['txt_login']}");
		}
		*/
		
		//var_dump("access denined");return;

		//header("Location: ".$session->referrer);
		
		if($res){
			header("Location: ".$session->referrer);
		} else {
			header("Location: ../denied.html");
		}
		
	}

	// логаут
	function proclogout() {
		global $session, $database, $logger;

		$logger->log("user logout: user_id = ".$session->user_id);

		// changelog deathorization
		//$database->logOfficeChange(CL_OF_UAC_LOGOUT, $session->of_id, 0, "Разавторизация. Пользователь '".$session->user_name."' (id:".$session->user_id.")");

		$session->logout();
		header("Location: ../main.php");
	}



//----------------------------------------------------------------------------------------------------------------


	function proc_get_db_options() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select * from db_options;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'option_name' => $row['option_name'],
			'int_value' => $row['int_value'],
			'str_value' => $row['str_value'],
			'date_value' => $row['date_value'],
			'float_value' => $row['float_value'],
			'description' => $row['description'],
			'param_type' => $row['param_type'],
			'param_name' => $row['param_name']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}


//-------------------------------------------------------------------------------------------------

	function proc_save_db_options() {
		global $session, $database, $logger;

		$option_name = $_REQUEST['option_name'];
		$int_value = $_REQUEST['int_value'];
		$str_value = $_REQUEST['str_value'];
		$date_value = $_REQUEST['date_value'];
		$float_value = $_REQUEST['float_value'];
		$description = $_REQUEST['description'];
		$param_type = $_REQUEST['param_type'];
		$param_name = $_REQUEST['param_name'];
		$rowmode = $_REQUEST['rowmode'];
		
		$q = <<<EOS
		execute procedure DB_OPTIONS_EDT(
			:OPTION_NAME,
			:INT_VALUE,
			:STR_VALUE,
			:DATE_VALUE,
			:FLOAT_VALUE,
			:DESCRIPTION,
			:PARAM_TYPE,
			:PARAM_NAME,
			:ROWMODE
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":OPTION_NAME",$option_name);
		$q->bindValue(":INT_VALUE",$int_value);
		$q->bindValue(":STR_VALUE",$str_value);
		$q->bindValue(":DATE_VALUE",$date_value);
		$q->bindValue(":FLOAT_VALUE",$float_value);
		$q->bindValue(":DESCRIPTION",$description);
		$q->bindValue(":PARAM_TYPE",$param_type);
		$q->bindValue(":PARAM_NAME",$param_name);
		$q->bindValue(":ROWMODE",$rowmode);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_sip_ip_transport() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select 
			id,
			protocol,
			ip,
			coalesce(port,'') as port,
			coalesce(name,'') as name,
			case when coalesce(cert_file,'')='' then ' ' else cert_file end as cert_file,
			case when coalesce(key_file,'')='' then ' ' else key_file end as key_file,
			coalesce(is_ip_v6,'') as is_ip_v6,
			sip_controller_id
		from tb_sip_ip_transports;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'protocol' => $row['protocol'],
			'ip' => $row['ip'],
			'port' => $row['port'],
			'name' => $row['name'],
			'cert_file' => $row['cert_file'] == 'null' ? '' : $row['cert_file'],
			'key_file' => $row['key_file'] == 'null' ? '' : $row['key_file'],
			'is_ip_v6' => $row['is_ip_v6'],
			'sip_controller_id' => $row['sip_controller_id']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}


	function proc_save_sip_ip_transport() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		$protocol = $_REQUEST['protocol'];
		$ip = $_REQUEST['ip'];
		$port = $_REQUEST['port'];
		$name = $_REQUEST['name'];
		$cert_file = $_REQUEST['cert_file'];
		$key_file = $_REQUEST['key_file'];
		$is_ip_v6 = $_REQUEST['is_ip_v6'];
		$sip_controller_id = $_REQUEST['sip_controller_id'] == 'null' ? null : $_REQUEST['sip_controller_id'];
		
		$q = <<<EOS
		execute procedure SIP_IP_TRANSPORT_EDT(
			:ID,
			:PROTOCOL,
			:IP,
			:PORT,
			:NAME,
			:CERT_FILE,
			:KEY_FILE,
			:IS_IP_V6,
			:SIP_CONTROLLER_ID
		)		
EOS;

		//$logger->log($q.'  id='.$id.'  protocol='.$protocol.'  port='.$port.'  is_ip_v6='.$is_ip_v6);

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":PROTOCOL",$protocol);
		$q->bindValue(":IP",$ip);
		$q->bindValue(":PORT",$port);
		$q->bindValue(":NAME",$name);
		$q->bindValue(":CERT_FILE",$cert_file,PDO::PARAM_LOB|PDO::PARAM_INPUT_OUTPUT);
		$q->bindValue(":KEY_FILE",$key_file,PDO::PARAM_LOB|PDO::PARAM_INPUT_OUTPUT);
		$q->bindValue(":IS_IP_V6",$is_ip_v6);
		$q->bindValue(":SIP_CONTROLLER_ID",$sip_controller_id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_del_sip_ip_transport() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		
		$q = <<<EOS
		execute procedure SIP_IP_TRANSPORT_DEL(
			:ID
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_sip_accounts() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select
			id,
			accounttypeid,
			tr_id,
			coalesce(dialplanid,'') as dialplanid,
			coalesce(fullname,'') as fullname,
			coalesce(calllimit,'') as calllimit,
			coalesce(name,'') as name,
			coalesce(secret,'') as secret,
			coalesce(secret_mode,'') as secret_mode,
			coalesce(reg_host,'') as reg_host,
			coalesce(reg_port,'') as reg_port,
			coalesce(expire,'') as expire,
			realm,
			type_name,
			type_desc,
			trans_protocol,
			trans_ip,
			trans_port,
			trans_name,
			coalesce(dialname,'') as dialname
		from get_sip_accounts;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'accounttypeid' => $row['accounttypeid'],
			'tr_id' => $row['tr_id'],
			
			'dialplanid' => $row['dialplanid'] == 'null' ? '' : $row['dialplanid'],
			'fullname' => $row['fullname'] == 'null' ? '' : $row['fullname'],
			'calllimit' => $row['calllimit'] == 'null' ? '' : $row['calllimit'],
			'name' => $row['name'] == 'null' ? '' : $row['name'],
			'secret' => $row['secret'] == 'null' ? '' : $row['secret'],
			'secret_mode' => $row['secret_mode'] == 'null' ? '' : $row['secret_mode'],

			'reg_host' => $row['reg_host'] == 'null' ? '' : $row['reg_host'],
			'reg_port' => $row['reg_port'] == 'null' ? '' : $row['reg_port'],
			'expire' => $row['expire'] == 'null' ? '' : $row['expire'],

			'realm' => $row['realm'],

			'type_name' => $row['type_name'],
			'type_desc' => $row['type_desc'],
			'trans_protocol' => $row['trans_protocol'],
			'trans_ip' => $row['trans_ip'],
			'trans_port' => $row['trans_port'],
			'trans_name' => $row['trans_name'],
			'dialname' => $row['dialname'] == 'null' ? '' : $row['dialname']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}

	function proc_get_sip_account_types() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select
			id,
			name,
			description
		from get_sip_account_types;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'name' => $row['name'],
			'description' => $row['description']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}

	function proc_save_sip_account() {
		global $session, $database, $logger;

		$id = empty($_REQUEST['id']) ? null : $_REQUEST['id'];
		$accounttypeid = $_REQUEST['accounttypeid'];
		$tr_id = $_REQUEST['tr_id'];
		$dialplanid = empty($_REQUEST['dialplanid']) ? null : $_REQUEST['dialplanid'];
		$fullname = $_REQUEST['fullname'];
		$calllimit = $_REQUEST['calllimit'];
		$name = $_REQUEST['name'];
		$secret = $_REQUEST['secret'];
		$secret_mode = $_REQUEST['secret_mode'];
		$reg_host = $_REQUEST['reg_host'];
		$reg_port = $_REQUEST['reg_port'];
		$expire = $_REQUEST['expire'];
		$realm = $_REQUEST['realm'];
		
		$q = <<<EOS
		execute procedure SIP_ACCOUNT_EDT(
			:ID,
			:ACCOUNTTYPEID,
			:TR_ID,
			:DIALPLANID,
			:FULLNAME,
			:CALLLIMIT,
			:NAME,
			:SECRET,
			:SECRET_MODE,
			:REG_HOST,
			:REG_PORT,
			:EXPIRE,
			:REALM
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":ACCOUNTTYPEID",$accounttypeid);
		$q->bindValue(":TR_ID",$tr_id);
		$q->bindValue(":DIALPLANID",$dialplanid);
		$q->bindValue(":FULLNAME",$fullname);
		$q->bindValue(":CALLLIMIT",$calllimit);
		$q->bindValue(":NAME",$name);
		$q->bindValue(":SECRET",$secret);
		$q->bindValue(":SECRET_MODE",$secret_mode);
		$q->bindValue(":REG_HOST",$reg_host);
		$q->bindValue(":REG_PORT",$reg_port);
		$q->bindValue(":EXPIRE",$expire);
		$q->bindValue(":REALM",$realm);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_del_sip_account() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		
		$q = <<<EOS
		execute procedure SIP_ACCOUNT_DEL(
			:ID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}
	

	function proc_get_active_sessions() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select 
			id,
			is_incoming,
			cid,
			ses_type,
			ses_type_id,
            account_type,
            trans_name,
			astatus,
			fstatus,
			attr_to,
			attr_from,
			owner_user,
			from_host,
			from_port,
			expire,
			create_time,
			update_time
		from get_active_sessions;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'is_incoming' => $row['is_incoming'],
			'cid' => $row['cid'],
			'ses_type' => $row['ses_type'],
			'ses_type_id' => $row['ses_type_id'],
			'account_type' => $row['account_type'],
			'trans_name' => $row['trans_name'],
			'astatus' => $row['astatus'],
			'fstatus' => $row['fstatus'],
			'attr_to' => $row['attr_to'],
			'attr_from' => $row['attr_from'],
			'owner_user' => $row['owner_user'],
			'from_host' => $row['from_host'],
			'from_port' => $row['from_port'],
			'expire' => $row['expire'],
			'create_time' => $row['create_time'],
			'update_time' => $row['update_time']
		);
		}
		
		//if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}

	function proc_get_archive_sessions() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select 
			id,
			is_incoming,
			cid,
			ses_type,
			ses_type_id,
            account_type,
            trans_name,
			astatus,
			fstatus,
			uri_to,
			uri_from,
			owner_user,
			from_host,
			from_port,
			expire,
			create_time,
			update_time
		from get_archive_sessions;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'is_incoming' => $row['is_incoming'],
			'cid' => $row['cid'],
			'ses_type' => $row['ses_type'],
			'ses_type_id' => $row['ses_type_id'],
			'account_type' => $row['account_type'],
			'trans_name' => $row['trans_name'],
			'astatus' => $row['astatus'],
			'fstatus' => $row['fstatus'],
			'uri_to' => $row['uri_to'],
			'uri_from' => $row['uri_from'],
			'owner_user' => $row['owner_user'],
			'from_host' => $row['from_host'],
			'from_port' => $row['from_port'],
			'expire' => $row['expire'],
			'create_time' => $row['create_time'],
			'update_time' => $row['update_time']
		);
		}
		
		//if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}
	
//------------------------------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------------------------------

	function proc_get_dialplans() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select
			dialplanid,
			coalesce(dialname,'') as dialname,
			step_pause,
			step_conf
		from get_dialplans;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('dialplanid' => null,'dialname' => null,'step_pause' => null,'step_conf' => null); 
		foreach($result as $key => $row){
		$res[$key] = array(
			'dialplanid' => $row['dialplanid'],
			'dialname' => $row['dialname'] == 'null' ? '' : $row['dialname'],
			'step_pause' => $row['step_pause'],
			'step_conf' => $row['step_conf']
		);
		}

		//$res[0] = array('dialplanid' => '0','dialname' => 'rtbrtbtbt'); 
		//$res[1] = array('dialplanid' => '1','dialname' => 'ytjyjtjya'); 

		echo json_encode($res);
	}
	
	function proc_save_dialplan() {
		global $session, $database, $logger;

		$dialplanid = $_REQUEST['dialplanid'];
		$dialname = $_REQUEST['dialname'];
		$step_pause = $_REQUEST['step_pause'];
		$step_conf = $_REQUEST['step_conf'];
		
		$step_pause = $step_pause > 0 ? $step_pause : null;
		$step_conf = $step_conf > 0 ? $step_conf : null;
		
		$q = <<<EOS
		execute procedure DIALPLAN_EDT(
			:DIALPLANID,
			:DIALNAME,
			:STEP_PAUSE,
			:STEP_CONF
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":DIALPLANID",$dialplanid);
		$q->bindValue(":DIALNAME",$dialname);
		$q->bindValue(":STEP_PAUSE",$step_pause);
		$q->bindValue(":STEP_CONF",$step_conf);
		
		$q->execute();
		$result = $q->fetchAll();
		//$res = array('result' => $result);

		echo json_encode($result);
	}

	function proc_del_dialplan() {
		global $session, $database, $logger;

		$dialplanid = $_REQUEST['dialplanid'];
		
		$q = <<<EOS
		execute procedure DIALPLAN_DEL(
			:DIALPLANID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":DIALPLANID",$dialplanid);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}
	
	function proc_save_dialpattern() {
		global $session, $database, $logger;

		$patternid = $_REQUEST['patternid'];
		$dialplanid = $_REQUEST['dialplanid'];
		$caller = $_REQUEST['caller'];
		$called = $_REQUEST['called'];
		$step = $_REQUEST['step'];
		$step_method = $_REQUEST['step_method'] == 'null' ? null : $_REQUEST['step_method'];
		
		$q = <<<EOS
		execute procedure PATTERN_EDT(
			:PATTERNID,
			:DIALPLANID,
			:CALLER,
			:CALLED,
			:STEP,
			:STEP_METHOD
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":PATTERNID",$patternid);
		$q->bindValue(":DIALPLANID",$dialplanid);
		$q->bindValue(":CALLER",$caller);
		$q->bindValue(":CALLED",$called);
		$q->bindValue(":STEP",$step);
		$q->bindValue(":STEP_METHOD",$step_method);
		
		$q->execute();
		$result = $q->fetchAll();
		//$res = array('result' => $result);

		echo json_encode($result);
	}
	

	function proc_get_dialpattern() {
		global $session, $database, $logger;

		$dialplanid = $_REQUEST['dialplanid'];
		
		$q = <<<EOS
		select 
			patternid,
			caller,
			called,
			step,
			step_method,
			step_method_desc
		from GET_DIALPATTERN(
			:DIALPLANID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":DIALPLANID",$dialplanid);
		
		$q->execute();
		$result = $q->fetchAll();
		//$res = array('result' => $result);
		$res[0] = array('patternid' => null,'caller' => null,'called' => null,'step' => null,'step_method' => null,'step_method_desc' => null); 
		foreach($result as $key => $row){
		$res[$key] = array(
			'patternid' => $row['patternid'],
			'caller' => $row['caller'] == 'null' ? '' : $row['caller'],
			'called' => $row['called'] == 'null' ? '' : $row['called'],
			'step' => $row['step'] == null ? '' : $row['step'],
			'step_method' => $row['step_method'],
			'step_method_desc' => $row['step_method_desc'] == 'null' ? '' : $row['step_method_desc']
		);
		}


		echo json_encode($res);
	}
	
	function proc_del_dialpattern() {
		global $session, $database, $logger;

		$patternid = $_REQUEST['patternid'];
		
		$q = <<<EOS
		execute procedure PATTERN_DEL(
			:PATTERNID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":PATTERNID",$patternid);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_sip_accounts_filterpage() {
		global $database, $session, $logger;

		$accountid = $_REQUEST['accountid'];
		$acctypeid = $_REQUEST['acctypeid'];
		$accname = $_REQUEST['accname'];
		$accfullname = $_REQUEST['accfullname'];
		$viewpage = $_REQUEST['viewpage'];
		
		$q = <<<EOS
		select
			id,
			accounttypeid,
			tr_id,
			coalesce(dialplanid,'') as dialplanid,
			coalesce(fullname,'') as fullname,
			coalesce(calllimit,'') as calllimit,
			coalesce(name,'') as name,
			coalesce(secret,'') as secret,
			coalesce(secret_mode,'') as secret_mode,
			coalesce(reg_host,'') as reg_host,
			coalesce(reg_port,'') as reg_port,
			coalesce(expire,'') as expire,
			coalesce(realm,'') as realm,
			type_name,
			type_desc,
			trans_protocol,
			trans_ip,
			trans_port,
			trans_name,
			pagecount
		from GET_SIP_ACCOUNTS_FILTERPAGE(
			:ACCOUNTID, 
			:ACCTYPEID,
			:ACCNAME,
			:ACCFULLNAME,
			:VIEWPAGE
		);
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":ACCOUNTID",$accountid);
		$q->bindValue(":ACCTYPEID",$acctypeid);
		$q->bindValue(":ACCNAME",$accname);
		$q->bindValue(":ACCFULLNAME",$accfullname);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'accounttypeid' => $row['accounttypeid'],
			'tr_id' => $row['tr_id'],
			
			'dialplanid' => $row['dialplanid'] == 'null' ? '' : $row['dialplanid'],
			'fullname' => $row['fullname'] == 'null' ? '' : $row['fullname'],
			'calllimit' => $row['calllimit'] == 'null' ? '' : $row['calllimit'],
			'name' => $row['name'] == 'null' ? '' : $row['name'],
			'secret' => $row['secret'] == 'null' ? '' : $row['secret'],
			'secret_mode' => $row['secret_mode'] == 'null' ? '' : $row['secret_mode'],

			'reg_host' => $row['reg_host'] == 'null' ? '' : $row['reg_host'],
			'reg_port' => $row['reg_port'] == 'null' ? '' : $row['reg_port'],
			'expire' => $row['expire'] == 'null' ? '' : $row['expire'],
			'realm' => $row['realm'] == 'null' ? '' : $row['realm'],

			'type_name' => $row['type_name'],
			'type_desc' => $row['type_desc'],
			'trans_protocol' => $row['trans_protocol'],
			'trans_ip' => $row['trans_ip'],
			'trans_port' => $row['trans_port'],
			'trans_name' => $row['trans_name'],
			'pagecount' => $row['pagecount']
		);
		}
		
		echo json_encode($res);
	}


	function proc_save_dialtarget() {
		global $session, $database, $logger;

		$targetid = $_REQUEST['targetid'];
		$patternid = $_REQUEST['patternid'];
		$accountid = $_REQUEST['accountid'];
		$modifier = $_REQUEST['modifier'];
		$modified = $_REQUEST['modified'];
		
		$q = <<<EOS
		execute procedure TARGET_EDT(
			:TARGETID,
			:PATTERNID,
			:ACCOUNTID,
			:MODIFIER,
			:MODIFIED
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":TARGETID",$targetid);
		$q->bindValue(":PATTERNID",$patternid);
		$q->bindValue(":ACCOUNTID",$accountid);
		$q->bindValue(":MODIFIER",$modifier);
		$q->bindValue(":MODIFIED",$modified);
		
		$q->execute();
		$result = $q->fetchAll();
		//$res = array('result' => $result);

		echo json_encode($result);
	}


	function proc_get_dialtarget() {
		global $session, $database, $logger;

		$patternid = $_REQUEST['patternid'];
		
		$q = <<<EOS
		select 
			targetid,
			patternid,
			accountid,
			modifier,
			modified,
			account_name
		from GET_DIALTARGET(
			:PATID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":PATID",$patternid);
		
		$q->execute();
		$result = $q->fetchAll();
		//$res = array('result' => $result);
		$res[0] = array('targetid' => null,'patternid' => null,'accountid' => null,'modifier' => null,'modified' => null,'account_name' => null); 
		foreach($result as $key => $row){
		$res[$key] = array(
			'targetid' => $row['targetid'],
			'patternid' => $row['patternid'],
			'accountid' => $row['accountid'],
			'modifier' => $row['modifier'] == 'null' ? '' : $row['modifier'],
			'modified' => $row['modified'] == 'null' ? '' : $row['modified'],
			'account_name' => $row['account_name'] == 'null' ? '' : $row['account_name']
		);
		}


		echo json_encode($res);
	}

	function proc_del_dialtarget() {
		global $session, $database, $logger;

		$targetid = $_REQUEST['targetid'];
		
		$q = <<<EOS
		execute procedure TARGET_DEL(
			:TARGETID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":TARGETID",$targetid);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_get_dialplan_filterpage() {
		global $database, $session, $logger;

		$dialplanid = $_REQUEST['filter_dialplanid'];
		$dialname = $_REQUEST['filter_dialname'];
		$viewpage = $_REQUEST['viewpage'];

		$q = <<<EOS
		select
			dialplan_id,
			dial_name,
			pagecount
		from GET_DIALPLANS_FILTERPAGE(
			:DIALPLANID, 
			:DIALNAME,
			:VIEWPAGE
		);
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":DIALPLANID",$dialplanid);
		$q->bindValue(":DIALNAME",$dialname);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('dialplanid' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'dialplanid' => $row['dialplan_id'],
			'dialname' => $row['dial_name'],
			'pagecount' => $row['pagecount']
		);
		}
		
		echo json_encode($res);
	}


	



	function proc_get_media_server() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select 
			id,
			coalesce(name,'') as name,
			coalesce(ip,'') as ip,
			port
		from tb_media_servers;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'name' => $row['name'],
			'ip' => $row['ip'],
			'port' => $row['port']
		);
		}
		
		echo json_encode($res);
	}

/*
	function proc_get_sip_controller() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select 
			id,
			name,
			rtp_port_start,
			rtp_port_count,
			media_server_id,
			media_server_name
		from GET_SIP_CONTROLLERS;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'name' => $row['name'],
			'rtp_port_start' => $row['rtp_port_start'],
			'rtp_port_count' => $row['rtp_port_count'],
			'media_server_id' => $row['media_server_id'],
			'media_server_name' => $row['media_server_name']
		);
		}
		
		echo json_encode($res);
	}
*/
	function proc_get_sip_controller() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select 
			id,
			name
		from GET_SIP_CONTROLLERS;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'name' => $row['name']
		);
		}
		
		echo json_encode($res);
	}


	function proc_save_media_server() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		$name = $_REQUEST['name'];
		$ip = $_REQUEST['ip'];
		$port = $_REQUEST['port'] == 'null' ? NULL : intval($_REQUEST['port'],10);

		$q = <<<EOS
		execute procedure MEDIA_SERVER_EDT(
			:ID,
			:NAME,
			:IP,
			:PORT
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":NAME",$name);
		$q->bindValue(":IP",$ip);
		$q->bindValue(":PORT",$port);
		
		$q->execute();
		$result = $q->fetchAll();
		//$res = array('result' => $result);

		$res[0] = array('id' => null,'result' => null); 
		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'result' => $row['result']
		);
		}

		echo json_encode($result);
	}

	function proc_del_media_server() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		
		$q = <<<EOS
		execute procedure MEDIA_SERVER_DEL(
			:ID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_sip_controller_server() {
		global $session, $database, $logger;

		$sip_controller_id = $_REQUEST['sip_controller_id'];
		
		$q = <<<EOS
		select 
			media_server_id,
			media_server_name,
			rtp_port_start,
			rtp_port_count
		from GET_SIP_CONTROLLER_SERVERS(
			:SIP_CONTROLLER_ID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":SIP_CONTROLLER_ID",$sip_controller_id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res[0] = array('media_server_id' => null,'media_server_name' => null,'rtp_port_start' => null,'rtp_port_count' => null); 
		foreach($result as $key => $row){
		$res[$key] = array(
			'media_server_id' => $row['media_server_id'],
			'media_server_name' => $row['media_server_name'] == 'null' ? '' : $row['media_server_name'],
			'rtp_port_start' => $row['rtp_port_start'],
			'rtp_port_count' => $row['rtp_port_count']
		);
		}


		echo json_encode($res);
	}


	function proc_save_sip_controller_server() {
		global $session, $database, $logger;

		$sip_controller_id = $_REQUEST['sip_controller_id'];
		$media_server_id = $_REQUEST['media_server_id'];
		$rtp_port_start = $_REQUEST['rtp_port_start'];
		$rtp_port_count = $_REQUEST['rtp_port_count'];

		$q = <<<EOS
		execute procedure SIP_CONTROLLER_SERVER_EDT(
			:SIP_CONTROLLER_ID,
			:MEDIA_SERVER_ID,
			:RTP_PORT_START,
			:RTP_PORT_COUNT
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":SIP_CONTROLLER_ID",$sip_controller_id);
		$q->bindValue(":MEDIA_SERVER_ID",$media_server_id);
		$q->bindValue(":RTP_PORT_START",$rtp_port_start);
		$q->bindValue(":RTP_PORT_COUNT",$rtp_port_count);
		
		$q->execute();
		$result = $q->fetchAll();
		//$res = array('result' => $result);

		$res[0] = array('result' => null); 
		foreach($result as $key => $row){
		$res[$key] = array(
			'result' => $row['result']
		);
		}

		echo json_encode($result);
	}

	function proc_del_sip_controller_server() {
		global $session, $database, $logger;

		$sip_controller_id = $_REQUEST['sip_controller_id'];
		$media_server_id = $_REQUEST['media_server_id'];
		
		$q = <<<EOS
		execute procedure SIP_CONTROLLER_SERVER_DEL(
			:SIP_CONTROLLER_ID,
			:MEDIA_SERVER_ID
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":SIP_CONTROLLER_ID",$sip_controller_id);
		$q->bindValue(":MEDIA_SERVER_ID",$media_server_id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}
	

	function proc_save_sip_controller() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		$name = $_REQUEST['name'];

		$q = <<<EOS
		execute procedure SIP_CONTROLLER_EDT(
			:ID,
			:NAME
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":NAME",$name);
		
		$q->execute();
		$result = $q->fetchAll();
		//$res = array('result' => $result);

		$res[0] = array('id' => null, 'result' => null); 
		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['conid'],
			'result' => $row['result']
		);
		}

		echo json_encode($res);
	}


	function proc_del_sip_controller() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		
		$q = <<<EOS
		execute procedure SIP_CONTROLLER_DEL(
			:ID
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_step_method() {
		global $session, $database, $logger;

		$q = <<<EOS
		select 
		step_method, 
		step_method_desc 
		from tb_step_method		
EOS;

		$q=$database->prepare($q);
		
		$q->execute();
		$result = $q->fetchAll();
		$res[0] = array('step_method' => null, 'step_method_desc' => null); 
		foreach($result as $key => $row){
		$res[$key] = array(
			'step_method' => $row['step_method'],
			'step_method_desc' => $row['step_method_desc']
		);
		}

		echo json_encode($res);
	}





	function proc_get_sip_accounts_basepage() {
		global $database, $session, $logger;

		$accresource = $_REQUEST['accresource'];
		$acctypeid = $_REQUEST['acctypeid'];
		$accfullname = $_REQUEST['accfullname'];
		$accname = $_REQUEST['accname'];
		$accid_1 = $_REQUEST['accid_1'];
		$accid_2 = $_REQUEST['accid_2'];
		$acchost = $_REQUEST['acchost'];
		$accdialid = $_REQUEST['accdialid'];
		$accdialname = $_REQUEST['accdialname'];
		$acctrid = $_REQUEST['acctrid'];
		$viewpage = $_REQUEST['viewpage'];
		
		$q = <<<EOS
		select
			id,
			accounttypeid,
			tr_id,
			dialplanid,
			coalesce(fullname,'') as fullname,
			calllimit,
			reglimit,
			coalesce(name,'') as name,
			coalesce(secret,'') as secret,
			secret_mode,
			coalesce(reg_host,'') as reg_host,
			reg_port,
			expire,
			coalesce(realm,'') as realm,
			coalesce(codec_set,'') as codec_set,
			coalesce(must_rec,'') as must_rec,
			coalesce(accounttype_name,'') as accounttype_name,
			coalesce(accounttype_desc,'') as accounttype_desc,
			coalesce(tr_protocol,'') as tr_protocol,
			coalesce(tr_ip,'') as tr_ip,
			tr_port,
			coalesce(tr_name,'') as tr_name,
			coalesce(dial_name,'') as dial_name,
			dial_step_pause,
			dial_step_conf,
			pagecount,
			reccount
		from GET_SIP_ACCOUNTS_BASEPAGE(
			:ACCRESOURCE,
			:ACCTYPEID,
			:ACCFULLNAME,
			:ACCNAME,
			:ACCID_1,
			:ACCID_2,
			:ACCHOST,
			:ACCDIALID,
			:ACCDIALNAME,
			:ACCTRID,
			:VIEWPAGE
		);
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":ACCRESOURCE",$accresource);
		$q->bindValue(":ACCTYPEID",$acctypeid);
		$q->bindValue(":ACCFULLNAME",$accfullname);
		$q->bindValue(":ACCNAME",$accname);
		$q->bindValue(":ACCID_1",$accid_1);
		$q->bindValue(":ACCID_2",$accid_2);
		$q->bindValue(":ACCHOST",$acchost);
		$q->bindValue(":ACCDIALID",$accdialid);
		$q->bindValue(":ACCDIALNAME",$accdialname);
		$q->bindValue(":ACCTRID",$acctrid);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'accounttypeid' => $row['accounttypeid'],
			'tr_id' => $row['tr_id'],
			'dialplanid' => $row['dialplanid'],
			'fullname' => $row['fullname'] == 'null' ? '' : $row['fullname'],
			'calllimit' => $row['calllimit'],
			'reglimit' => $row['reglimit'],
			'name' => $row['name'] == 'null' ? '' : $row['name'],
			'secret' => $row['secret'] == 'null' ? '' : $row['secret'],
			'secret_mode' => $row['secret_mode'],
			'reg_host' => $row['reg_host'] == 'null' ? '' : $row['reg_host'],
			'reg_port' => $row['reg_port'],
			'expire' => $row['expire'],
			'realm' => $row['realm'] == 'null' ? '' : $row['realm'],
			'codec_set' => $row['codec_set'] == 'null' ? '' : $row['codec_set'],
			'must_rec' => $row['must_rec'] == 'null' ? '' : $row['must_rec'],
			'accounttype_name' => $row['accounttype_name'] == 'null' ? '' : $row['accounttype_name'],
			'accounttype_desc' => $row['accounttype_desc'] == 'null' ? '' : $row['accounttype_desc'],
			'tr_protocol' => $row['tr_protocol'] == 'null' ? '' : $row['tr_protocol'],
			'tr_ip' => $row['fullname'] == 'tr_ip' ? '' : $row['tr_ip'],
			'tr_port' => $row['tr_port'],
			'tr_name' => $row['tr_name'] == 'null' ? '' : $row['tr_name'],
			'dial_name' => $row['dial_name'] == 'null' ? '' : $row['dial_name'],
			'dial_step_pause' => $row['dial_step_pause'],
			'dial_step_conf' => $row['dial_step_conf'],
			'pagecount' => $row['pagecount'],
			'reccount' => $row['reccount']
		);
		}
		
		echo json_encode($res);
	}



	function proc_check_sip_account_name() {
		global $database, $session, $logger;

		$name = $_REQUEST['name'];
		
		$q = <<<EOS
		select
			case when count(*)>=1 then 1 else 0 end as name_exist
		from TB_SIP_ACCOUNTS where name = :NAME;
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":NAME",$name);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('name_exist' => 0); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'name_exist' => $row['name_exist']
		);
		}
		
		echo json_encode($res);
	}

	// ------------------------------------------------------------------------------------------
	// 			opensips 
	// ------------------------------------------------------------------------------------------
		
	function proc_get_domain() {
		global $database, $session, $logger;

		$q = <<<EOS
		select
			id,
			domain,
			attrs,
			last_modified
		from domain order by id;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'domain' => $row['domain'],
			'attrs' => $row['attrs'],
			'last_modified' => $row['last_modified']
		);
		}
		
		echo json_encode($res);
	}

	function proc_save_domain() {
		global $session, $database, $logger;

		$id = empty($_REQUEST['id']) ? NULL : $_REQUEST['id'];
		$domain = $_REQUEST['domain'];
		$attrs = $_REQUEST['attrs'];
		$row_mode = $_REQUEST['row_mode'];
		
		$q = <<<EOS
		execute procedure DOMAIN_EDT(
			:ID,
			:DOMAIN,
			:ATTRS,
			:ROW_MODE
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":DOMAIN",$domain);
		$q->bindValue(":ATTRS",$attrs);
		$q->bindValue(":ROW_MODE",$row_mode);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}
		
	function proc_get_subscriber_page() {
		global $database, $session, $logger;

		$username = $_REQUEST['username'];
		$domain = $_REQUEST['domain'];
		$email_address = $_REQUEST['email_address'];
		$viewpage = $_REQUEST['viewpage'];
		
		$q = <<<EOS
        select
            ID,
            USERNAME,
            "DOMAIN",
            "PASSWORD",
            EMAIL_ADDRESS,
            HA1,
            HA1_SHA256,
            HA1_SHA512T256,
            RPID,
            RECORDER_ADDRESS,
            PROXY_MEDIA,
			CONTACT_COUNT,
            pagecount,
            reccount
        from GET_SUBSCRIBER_PAGE(
            :USERNAME,
            :DOMAIN,
            :EMAIL_ADDRESS,
            :VIEWPAGE
		);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":USERNAME",$username);
		$q->bindValue(":DOMAIN",$domain);
		$q->bindValue(":EMAIL_ADDRESS",$email_address);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'username' => empty($row['username']) ? '' : $row['username'],
			'domain' => empty($row['domain']) ? '' : $row['domain'],
			'username_full' => empty($row['domain']) ? $row['username'] : $row['username'].'@'.$row['domain'],
			'email_address' => empty($row['email_address']) ? '' : $row['email_address'],
			//'ha1' => empty($row['ha1']) ? '' : $row['ha1'],
			//'ha1_sha256' => empty($row['ha1_sha256']) ? '' : $row['ha1_sha256'],
			//'ha1_sha512t256' => empty($row['ha1_sha512t256']) ? '' : $row['ha1_sha512t256'],
			'password' => '',
			'ha1' => '',
			'ha1_sha256' => '',
			'ha1_sha512t256' => '',
			'rpid' => empty($row['rpid']) ? '' : $row['rpid'],
			'recorder_address' => empty($row['recorder_address']) ? '' : $row['recorder_address'],
			'proxy_media' => $row['proxy_media'],
			'contact_count' => $row['contact_count'],
			'pagecount' => $row['pagecount'],
			'reccount' => $row['reccount']
		);
		}
		
		
		echo json_encode($res);
	}

	function proc_save_subscriber() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		$username = empty($_REQUEST['username']) ? null : $_REQUEST['username'];
		//$domain = empty($_REQUEST['domain']) ? null : $_REQUEST['domain'];
		$domain = $_REQUEST['domain'];
		$password = empty($_REQUEST['password']) ? '' : $_REQUEST['password'];
		$email = empty($_REQUEST['email']) ? '' : $_REQUEST['email'];
		$recorder_address = empty($_REQUEST['recorder_address']) ? null : $_REQUEST['recorder_address'];
		$proxy_media = $_REQUEST['proxy_media'];

		$q = <<<EOS
		execute procedure SUBSCRIBER_EDT(
            :ID,
			:USERNAME,
			:DOMAIN,
			:PASSWORD,
			:EMAIL,
			:RECORDER_ADDRESS,
			:PROXY_MEDIA
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":USERNAME",$username);
		$q->bindValue(":DOMAIN",$domain);
		$q->bindValue(":PASSWORD",$password);
		$q->bindValue(":EMAIL",$email);
		$q->bindValue(":RECORDER_ADDRESS",$recorder_address);
		$q->bindValue(":PROXY_MEDIA",$proxy_media);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_del_subscriber() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		
		$q = <<<EOS
		execute procedure SUBSCRIBER_DEL(
			:ID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_user_location() {
		global $database, $session, $logger;

		$username = $_REQUEST['username'];
		$domain = $_REQUEST['domain'];
		
		$q = <<<EOS
		select 
			CONTACT_ID,
			USERNAME,
			"DOMAIN",
			CONTACT,
			RECEIVED,
			PATH,
			EXPIRES,
			Q,
			CALLID,
			CSEQ,
			LAST_MODIFIED,
			FLAGS,
			CFLAGS,
			USER_AGENT,
			SOCKET,
			METHODS,
			SIP_INSTANCE,
			KV_STORE,
			ATTR
		from GET_USER_LOCATION(
			:USERNAME,
            :DOMAIN);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":USERNAME",$username);
		$q->bindValue(":DOMAIN",$domain);
		
		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('contact_id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'contact_id' => $row['contact_id'],
			'username' => empty($row['username']) ? '' : $row['username'],
			'domain' => empty($row['domain']) ? '' : $row['domain'],
			'contact' => empty($row['contact']) ? '' : $row['contact'],
			'received' => empty($row['received']) ? '' : $row['received'],
			'path' => empty($row['path']) ? '' : $row['path'],
			'expires' => $row['expires'],
			'q' => $row['q'],
			'callid' => empty($row['callid']) ? '' : $row['callid'],
			'cseq' => $row['cseq'],
			'last_modified' => $row['last_modified'],
			'flags' => $row['flags'],
			'cflags' => empty($row['cflags']) ? '' : $row['cflags'],
			'user_agent' => empty($row['user_agent']) ? '' : $row['user_agent'],
			'socket' => empty($row['socket']) ? '' : $row['socket'],
			'methods' => $row['methods'],
			'sip_instance' => empty($row['sip_instance']) ? '' : $row['sip_instance'],
			'kv_store' => empty($row['kv_store']) ? '' : $row['kv_store'],
			'attr' => empty($row['attr']) ? '' : $row['attr']
		);
		}
		
		echo json_encode($res);
	}


	function proc_get_registrant_page() {
		global $database, $session, $logger;

		$username = $_REQUEST['username'];
		$registrar = $_REQUEST['registrar'];
		$viewpage = $_REQUEST['viewpage'];
		
		$q = <<<EOS
        select
			ID,
			REGISTRAR,
			PROXY,
			AOR,
			THIRD_PARTY_REGISTRANT,
			USERNAME,
			"PASSWORD",
			BINDING_URI,
			BINDING_PARAMS,
			EXPIRY,
			FORCED_SOCKET,
			CLUSTER_SHTAG,
			STATE,
            pagecount,
            reccount
        from GET_REGISTRANT_PAGE(
			:USERNAME,
			:REGISTRAR,
			:VIEWPAGE
		);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":USERNAME",$username);
		$q->bindValue(":REGISTRAR",$registrar);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'registrar' => empty($row['registrar']) ? '' : $row['registrar'],
			'proxy' => empty($row['proxy']) ? '' : $row['proxy'],
			'aor' => empty($row['aor']) ? '' : $row['aor'],
			'third_party_registrant' => empty($row['third_party_registrant']) ? '' : $row['third_party_registrant'],
			'username' => empty($row['username']) ? '' : $row['username'],
			'password' => '',
			'binding_uri' => empty($row['binding_uri']) ? '' : $row['binding_uri'],
			'binding_params' => empty($row['binding_params']) ? '' : $row['binding_params'],
			'expiry' => $row['expiry'],
			'forced_socket' => empty($row['forced_socket']) ? '' : $row['forced_socket'],
			'cluster_shtag' => empty($row['cluster_shtag']) ? '' : $row['cluster_shtag'],
			'state' => $row['state'],
			'pagecount' => $row['pagecount'],
			'reccount' => $row['reccount']
		);
		}
		
		
		echo json_encode($res);
	}

	function proc_save_registrant() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		$registrar = empty($_REQUEST['registrar']) ? null : $_REQUEST['registrar'];
		$proxy = empty($_REQUEST['proxy']) ? null : $_REQUEST['proxy'];
		$aor = empty($_REQUEST['aor']) ? null : $_REQUEST['aor'];
		$third_party_registrant = empty($_REQUEST['third_party_registrant']) ? null : $_REQUEST['third_party_registrant'];
		$username = empty($_REQUEST['username']) ? null : $_REQUEST['username'];
		$password = empty($_REQUEST['password']) ? null : $_REQUEST['password'];
		$binding_uri = empty($_REQUEST['binding_uri']) ? null : $_REQUEST['binding_uri'];
		$binding_params = empty($_REQUEST['binding_params']) ? null : $_REQUEST['binding_params'];
		$expiry = empty($_REQUEST['expiry']) ? null : $_REQUEST['expiry'];
		$forced_socket = empty($_REQUEST['forced_socket']) ? null : $_REQUEST['forced_socket'];
		$cluster_shtag = empty($_REQUEST['cluster_shtag']) ? null : $_REQUEST['cluster_shtag'];
		$state = $_REQUEST['state'];


		$q = <<<EOS
		execute procedure REGISTRANT_EDT(
			:ID,
			:REGISTRAR,
			:PROXY,
			:AOR,
			:THIRD_PARTY_REGISTRANT,
			:USERNAME,
			:PASSWORD,
			:BINDING_URI,
			:BINDING_PARAMS,
			:EXPIRY,
			:FORCED_SOCKET,
			:CLUSTER_SHTAG,
			:STATE
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":REGISTRAR",$registrar);
		$q->bindValue(":PROXY",$proxy);
		$q->bindValue(":AOR",$aor);
		$q->bindValue(":THIRD_PARTY_REGISTRANT",$third_party_registrant);
		$q->bindValue(":USERNAME",$username);
		$q->bindValue(":PASSWORD",$password);
		$q->bindValue(":BINDING_URI",$binding_uri);
		$q->bindValue(":BINDING_PARAMS",$binding_params);
		$q->bindValue(":EXPIRY",$expiry);
		$q->bindValue(":FORCED_SOCKET",$forced_socket);
		$q->bindValue(":CLUSTER_SHTAG",$cluster_shtag);
		$q->bindValue(":STATE",$state);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_del_registrant() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		
		$q = <<<EOS
		execute procedure REGISTRANT_DEL(
			:ID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_gateway_page() {
		global $database, $session, $logger;

		$address = $_REQUEST['address'];
		$description = $_REQUEST['description'];
		$viewpage = $_REQUEST['viewpage'];
		
		$q = <<<EOS
			select
			id,
			gwid,
			"TYPE",
			ADDRESS,
			strip,
			pri_prefix,
			attrs,
			probe_mode,
			state,
			socket,
			description,
            pagecount,
            reccount
        from GET_GATEWAYS_PAGE(
			:ADDRESS,
			:DESCRIPTION,
			:VIEWPAGE
		);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ADDRESS",$address);
		$q->bindValue(":DESCRIPTION",$description);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'gwid' => empty($row['gwid']) ? '' : $row['gwid'],
			'type' => $row['type'],
			'address' => empty($row['address']) ? '' : $row['address'],
			'strip' => $row['strip'],
			'pri_prefix' => empty($row['pri_prefix']) ? '' : $row['pri_prefix'],
			'attrs' => empty($row['attrs']) ? '' : $row['attrs'],
			'probe_mode' => $row['probe_mode'],
			'state' => $row['state'],
			'socket' => empty($row['socket']) ? '' : $row['socket'],
			'description' => empty($row['description']) ? '' : $row['description'],
			'pagecount' => $row['pagecount'],
			'reccount' => $row['reccount']
		);
		}
		
		
		echo json_encode($res);
	}



	function proc_get_gateway_set() {
		global $database, $session, $logger;

		$address = $_REQUEST['address'];
		$description = $_REQUEST['description'];
		
		$q = <<<EOS
			select
			id,
			gwid,
			"TYPE",
			ADDRESS,
			strip,
			pri_prefix,
			attrs,
			probe_mode,
			state,
			socket,
			description
        from GET_GATEWAYS_SET(
			:ADDRESS,
			:DESCRIPTION
		);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ADDRESS",$address);
		$q->bindValue(":DESCRIPTION",$description);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'gwid' => empty($row['gwid']) ? '' : $row['gwid'],
			'type' => $row['type'],
			'address' => empty($row['address']) ? '' : $row['address'],
			'strip' => $row['strip'],
			'pri_prefix' => empty($row['pri_prefix']) ? '' : $row['pri_prefix'],
			'attrs' => empty($row['attrs']) ? '' : $row['attrs'],
			'probe_mode' => $row['probe_mode'],
			'state' => $row['state'],
			'socket' => empty($row['socket']) ? '' : $row['socket'],
			'description' => empty($row['description']) ? '' : $row['description']
		);
		}
		
		echo json_encode($res);
	}




	function proc_save_gateway() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		//$gwid = empty($_REQUEST['gwid']) ? 'gw' : $_REQUEST['gwid'];
		$gwid = empty($_REQUEST['gwid']) ? '' : $_REQUEST['gwid'];
		$type = empty($_REQUEST['type']) ? 0 : $_REQUEST['type'];
		$address = empty($_REQUEST['address']) ? '' : $_REQUEST['address'];
		$strip = empty($_REQUEST['strip']) ? 0 : $_REQUEST['strip'];
		$pri_prefix = empty($_REQUEST['pri_prefix']) ? null : $_REQUEST['pri_prefix'];
		$attrs = empty($_REQUEST['attrs']) ? null : $_REQUEST['attrs'];
		$probe_mode = $_REQUEST['probe_mode'];
		$state = $_REQUEST['state'];
		$socket = empty($_REQUEST['socket']) ? null : $_REQUEST['socket'];
		$description = empty($_REQUEST['description']) ? null : $_REQUEST['description'];

		$q = <<<EOS
		execute procedure GATEWAYS_EDT(
			:ID,
			:GWID,
			:TYPE,
			:ADDRESS,
			:STRIP,
			:PRI_PREFIX,
			:ATTRS,
			:PROBE_MODE,
			:STATE,
			:SOCKET,
			:DESCRIPTION
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":GWID",$gwid);
		$q->bindValue(":TYPE",$type);
		$q->bindValue(":ADDRESS",$address);
		$q->bindValue(":STRIP",$strip);
		$q->bindValue(":PRI_PREFIX",$pri_prefix);
		$q->bindValue(":ATTRS",$attrs);
		$q->bindValue(":PROBE_MODE",$probe_mode);
		$q->bindValue(":STATE",$state);
		$q->bindValue(":SOCKET",$socket);
		$q->bindValue(":DESCRIPTION",$description);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_del_gateway() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		
		$q = <<<EOS
		execute procedure GATEWAYS_DEL(
			:ID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_cdr_acc_page() {
		global $database, $session, $logger;

		$create_D1 = $_REQUEST['create_D1'];
		$create_T1 = $_REQUEST['create_T1'];
		$create_D2 = $_REQUEST['create_D2'];
		$create_T2 = $_REQUEST['create_T2'];
		$method = $_REQUEST['method'];
		$recpage = $_REQUEST['recpage'];
		$viewpage = $_REQUEST['viewpage'];
		
		$q = <<<EOS
        select
			id,
			method,
			from_tag,
			to_tag,
			callid,
			sip_code,
			sip_reason,
			time_cmpl,
			duration,
			ms_duration,
			setuptime,
			created,
			src_ip,
			dst_ip,
			peer_name,
            pagecount,
            reccount,
			dest_name,
			dest_addr
        from GET_CDR_ACC_PAGE(
			:CREATE_D1,
			:CREATE_T1,
			:CREATE_D2,
			:CREATE_T2,
			:METHOD,
			:RECPAGE,
			:VIEWPAGE
		);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":CREATE_D1",$create_D1);
		$q->bindValue(":CREATE_T1",$create_T1);
		$q->bindValue(":CREATE_D2",$create_D2);
		$q->bindValue(":CREATE_T2",$create_T2);
		$q->bindValue(":METHOD",$method);
		$q->bindValue(":RECPAGE",$recpage);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null,'pagecount' => 0,'reccount' => 0); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'method' => empty($row['method']) ? '' : $row['method'],
			'from_tag' => empty($row['from_tag']) ? '' : $row['from_tag'],
			'to_tag' => empty($row['to_tag']) ? '' : $row['to_tag'],
			'callid' => empty($row['callid']) ? '' : $row['callid'],
			'sip_code' => empty($row['sip_code']) ? '' : $row['sip_code'],
			'sip_reason' => empty($row['sip_reason']) ? '' : $row['sip_reason'],
			'time_cmpl' => empty($row['time_cmpl']) ? '' : $row['time_cmpl'],
			'duration' => empty($row['duration']) ? '' : $row['duration'],
			'ms_duration' => empty($row['ms_duration']) ? '' : $row['ms_duration'],
			'setuptime' => empty($row['setuptime']) ? '' : $row['setuptime'],
			'created' => empty($row['created']) ? '' : $row['created'],
			'src_ip' => empty($row['src_ip']) ? '' : $row['src_ip'],
			'dst_ip' => empty($row['dst_ip']) ? '' : $row['dst_ip'],
			'peer_name' => empty($row['peer_name']) ? '' : $row['peer_name'],
			'dest_name' => empty($row['dest_name']) ? '' : $row['dest_name'],
			'dest_addr' => empty($row['dest_addr']) ? '' : $row['dest_addr'],
			'pagecount' => $row['pagecount'],
			'reccount' => $row['reccount']
		);
		}
		
		echo json_encode($res);
	}

	function proc_get_cdr_mc_page() {
		global $database, $session, $logger;

		$create_D1 = $_REQUEST['create_D1'];
		$create_T1 = $_REQUEST['create_T1'];
		$create_D2 = $_REQUEST['create_D2'];
		$create_T2 = $_REQUEST['create_T2'];
		$method = $_REQUEST['method'];
		$recpage = $_REQUEST['recpage'];
		$viewpage = $_REQUEST['viewpage'];
		
		$q = <<<EOS
        select
			id,
			method,
			from_tag,
			to_tag,
			callid,
			sip_code,
			sip_reason,
			time_cmpl,
			setuptime,
			created,
			src_ip,
			dst_ip,
			peer_name,
			dest_name,
			dest_addr,
            pagecount,
            reccount
        from GET_CDR_MISSED_CALLS_PAGE(
			:CREATE_D1,
			:CREATE_T1,
			:CREATE_D2,
			:CREATE_T2,
			:METHOD,
			:RECPAGE,
			:VIEWPAGE
		);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":CREATE_D1",$create_D1);
		$q->bindValue(":CREATE_T1",$create_T1);
		$q->bindValue(":CREATE_D2",$create_D2);
		$q->bindValue(":CREATE_T2",$create_T2);
		$q->bindValue(":METHOD",$method);
		$q->bindValue(":RECPAGE",$recpage);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null,'pagecount' => 0,'reccount' => 0); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'method' => empty($row['method']) ? '' : $row['method'],
			'from_tag' => empty($row['from_tag']) ? '' : $row['from_tag'],
			'to_tag' => empty($row['to_tag']) ? '' : $row['to_tag'],
			'callid' => empty($row['callid']) ? '' : $row['callid'],
			'sip_code' => empty($row['sip_code']) ? '' : $row['sip_code'],
			'sip_reason' => empty($row['sip_reason']) ? '' : $row['sip_reason'],
			'time_cmpl' => empty($row['time_cmpl']) ? '' : $row['time_cmpl'],
			'setuptime' => empty($row['setuptime']) ? '' : $row['setuptime'],
			'created' => empty($row['created']) ? '' : $row['created'],
			'src_ip' => empty($row['src_ip']) ? '' : $row['src_ip'],
			'dst_ip' => empty($row['dst_ip']) ? '' : $row['dst_ip'],
			'peer_name' => empty($row['peer_name']) ? '' : $row['peer_name'],
			'dest_name' => empty($row['dest_name']) ? '' : $row['dest_name'],
			'dest_addr' => empty($row['dest_addr']) ? '' : $row['dest_addr'],
			'pagecount' => $row['pagecount'],
			'reccount' => $row['reccount']
		);
		}
		
		echo json_encode($res);
	}

//-----------------------------------------------------------------------

	function proc_get_gwrule_page() {
		global $database, $session, $logger;

		$gwid = $_REQUEST['gwid'];
		$gwlist = $_REQUEST['gwlist'];
		$f_description = $_REQUEST['description'];
		$viewpage = $_REQUEST['viewpage'];
		
		$q = <<<EOS
			select 
			ruleid,
			groupid,
			prefix,
			timerec,
			priority,
			routeid,
			gwlist,
			sort_alg,
			sort_profile,
			attrs,
			description,
			rule_type_id,
			rule_type_name,
            pagecount,
            reccount
        from GET_RULES_PAGE(
			:GWID,
			:GWLIST,
			:F_DESCRIPTION,
			:VIEWPAGE
		);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":GWID",$gwid);
		$q->bindValue(":GWLIST",$gwlist);
		$q->bindValue(":F_DESCRIPTION",$f_description);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('ruleid' => null); 

		/*foreach($result as $key => $row){
		$res[$key] = array(
			'ruleid' => $row['ruleid'],
			//'groupid' => empty($row['groupid']) ? '' : $row['groupid'],
			'groupid' => $row['groupid'],
			'prefix' => empty($row['prefix']) ? '' : $row['prefix'],
			//'timerec' => empty($row['timerec']) ? '' : $row['timerec'],
			'timerec' => $row['timerec'],
			'priority' => $row['priority'],
			'routeid' => empty($row['routeid']) ? '' : $row['routeid'],
			'gwlist' => empty($row['gwlist']) ? '' : $row['gwlist'],
			'sort_alg' => empty($row['sort_alg']) ? '' : $row['sort_alg'],
			'sort_profile' => $row['sort_profile'],
			'attrs' => empty($row['attrs']) ? '' : $row['attrs'],
			'description' => empty($row['description']) ? '' : $row['description'],
			'pagecount' => $row['pagecount'],
			'reccount' => $row['reccount']
		);
		}*/
		foreach($result as $key => $row){
		$res[$key] = array(
			'ruleid' => $row['ruleid'],
			'groupid' => $row['groupid'],
			'prefix' => $row['prefix'],
			'timerec' => $row['timerec'],
			'priority' => $row['priority'],
			'routeid' => $row['routeid'],
			'gwlist' => $row['gwlist'],
			'sort_alg' => $row['sort_alg'],
			'sort_profile' => $row['sort_profile'],
			'attrs' => $row['attrs'],
			'description' => $row['description'],
			'rule_type_id' => $row['rule_type_id'],
			'rule_type_name' => $row['rule_type_name'],
			'pagecount' => $row['pagecount'],
			'reccount' => $row['reccount']
		);
		}

		
		
		echo json_encode($res);
	}

	function proc_save_rule() {
		global $session, $database, $logger;
        $ruleid = (empty($_REQUEST['ruleid']) || $_REQUEST['ruleid']==0) ? null : $_REQUEST['ruleid'];
        //$groupid = $_REQUEST['groupid'];
        $groupid = empty($_REQUEST['groupid']) ? '0' : $_REQUEST['groupid'];
        $prefix = empty($_REQUEST['prefix']) ? '' : $_REQUEST['prefix'];
        $timerec = empty($_REQUEST['timerec']) ? null : $_REQUEST['timerec'];
        $priority = empty($_REQUEST['priority']) ? 0 : $_REQUEST['priority'];
        $routeid = empty($_REQUEST['routeid']) ? null : $_REQUEST['routeid'];
        $gwlist = empty($_REQUEST['gwlist']) ? null : $_REQUEST['gwlist'];
        //$sort_alg = empty($_REQUEST['sort_alg']) ? 'N' : strval( $_REQUEST['sort_alg'] );
        $sort_alg = $_REQUEST['sort_alg']=='' ? 'N' : strval( $_REQUEST['sort_alg'] );
        $sort_profile = $_REQUEST['sort_profile'];
		$attrs = empty($_REQUEST['attrs']) ? null : $_REQUEST['attrs'];
		$description = empty($_REQUEST['description']) ? null : $_REQUEST['description'];
		$rule_type_id = $_REQUEST['rule_type_id'];
		
		//$rule_type_id = 1;

        /*$ruleid = null;
        $groupid = '1';
        $prefix = '2';
        $timerec = '3';
        $priority = 0;
        $routeid = '4';
        $gwlist = '5';
        $sort_alg = '6';
        $sort_profile = 2;
		$attrs = '5';
		$description = '5';*/

		$q = <<<EOS
		execute procedure RULES_EDT(
			:RULEID,
			:GROUPID,
			:PREFIX,
			:TIMEREC,
			:PRIORITY,
			:ROUTEID,
			:GWLIST,
			:SORT_ALG,
			:SORT_PROFILE,
			:ATTRS,
			:DESCRIPTION,
			:RULE_TYPE_ID
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":RULEID",$ruleid);
		$q->bindValue(":GROUPID",$groupid);
		$q->bindValue(":PREFIX",$prefix);
		$q->bindValue(":TIMEREC",$timerec);
		$q->bindValue(":PRIORITY",$priority);
		$q->bindValue(":ROUTEID",$routeid);
		$q->bindValue(":GWLIST",$gwlist);
		$q->bindValue(":SORT_ALG",$sort_alg);
		$q->bindValue(":SORT_PROFILE",$sort_profile);
		$q->bindValue(":ATTRS",$attrs);
		$q->bindValue(":DESCRIPTION",$description);
		$q->bindValue(":RULE_TYPE_ID",$rule_type_id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_del_rule() {
		global $session, $database, $logger;

		$ruleid = $_REQUEST['ruleid'];
		
		$q = <<<EOS
		execute procedure RULES_DEL(
			:RULEID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":RULEID",$ruleid);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_select_gateway_page() {
		global $database, $session, $logger;

		$address = $_REQUEST['address'];
		$description = $_REQUEST['description'];
		$viewpage = $_REQUEST['viewpage'];
		
		$q = <<<EOS
			select
			id,
			gwid,
			"TYPE",
			ADDRESS,
			strip,
			pri_prefix,
			attrs,
			probe_mode,
			state,
			socket,
			description,
            pagecount,
            reccount
        from GET_GATEWAYS_PAGE(
			:ADDRESS,
			:DESCRIPTION,
			:VIEWPAGE
		);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ADDRESS",$address);
		$q->bindValue(":DESCRIPTION",$description);
		$q->bindValue(":VIEWPAGE",$viewpage);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'gwid' => empty($row['gwid']) ? '' : $row['gwid'],
			'type' => $row['type'],
			'address' => empty($row['address']) ? '' : $row['address'],
			'strip' => $row['strip'],
			'pri_prefix' => empty($row['pri_prefix']) ? '' : $row['pri_prefix'],
			'attrs' => empty($row['attrs']) ? '' : $row['attrs'],
			'probe_mode' => $row['probe_mode'],
			'state' => $row['state'],
			'socket' => empty($row['socket']) ? '' : $row['socket'],
			'description' => empty($row['description']) ? '' : $row['description'],
			'pagecount' => $row['pagecount'],
			'reccount' => $row['reccount']
		);
		}
		
		
		echo json_encode($res);
	}


	function proc_get_user() {
		global $database, $session, $logger;

		$q = <<<EOS
		select
		user_id,
		user_name,
		user_pass,
		user_fio
		from GET_USER;
EOS;

		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('user_id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'user_id' => $row['user_id'],
			'user_name' => empty($row['user_name']) ? '' : $row['user_name'],
			'user_pass' => empty($row['user_pass']) ? '' : $row['user_pass'],
			'user_fio' => empty($row['user_fio']) ? '' : $row['user_fio']
		);
		}
		
		echo json_encode($res);
	}

	function proc_save_user() {
		global $session, $database, $logger;

		$user_id = $_REQUEST['user_id']<1 ? null : $_REQUEST['user_id'];
		$user_name = empty($_REQUEST['user_name']) ? null : $_REQUEST['user_name'];
		$user_pass = empty($_REQUEST['user_pass']) ? null : $_REQUEST['user_pass'];
		$user_fio = empty($_REQUEST['user_fio']) ? null : $_REQUEST['user_fio'];

		//$user_id = null;
		//$user_name = '1';
		//$user_pass = '3';
		//$user_fio = '2';

		$q = <<<EOS
		execute procedure USER_EDT(
			:USER_ID,
			:USER_NAME,
			:USER_PASS,
			:USER_FIO
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":USER_ID",$user_id);
		$q->bindValue(":USER_NAME",$user_name);
		$q->bindValue(":USER_PASS",$user_pass);
		$q->bindValue(":USER_FIO",$user_fio);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_del_user() {
		global $session, $database, $logger;

		$user_id = $_REQUEST['user_id'];
		
		$q = <<<EOS
		execute procedure USER_DEL(
			:USER_ID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":USER_ID",$user_id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


/*
	function proc_execute_command(){
		$cmd = $_REQUEST['cmd'];
		$cmd = str_replace('\"','"',$cmd);
		$res = shell_exec($cmd);
		//escapeshellcmd() 
		//$res = exec("opensips-cli -x mi reg_reload");
		//$res = shell_exec("opensips-cli -x mi reg_reload");
		echo json_encode($res);
	}
*/

	function proc_opensips_reg_reload(){
		$url = "http://127.0.0.1:8888/mi";
		$data = array(
		  'jsonrpc' => '2.0', 
		  'id'      => 1,
		  //'method'  => 'reg_list'
		  'method'  => 'reg_reload'
		);
		$options = array(
		  'http' => array(
			'method'  => 'POST',
			'content' => json_encode( $data ),
			'header'=>  "Content-Type: application/json\r\n" .
						"Accept: application/json\r\n"
			)
		);
		$context  = stream_context_create( $options );
		$result = file_get_contents( $url, false, $context );
		//$response = json_encode( $result );
		//echo $response;
		echo $result;
	}

	function proc_opensips_dr_reload(){
		$url = "http://127.0.0.1:8888/mi";
		$data = array(
		  'jsonrpc' => '2.0', 
		  'id'      => 1,
		  'method'  => 'dr_reload'
		);
		$options = array(
		  'http' => array(
			'method'  => 'POST',
			'content' => json_encode( $data ),
			'header'=>  "Content-Type: application/json\r\n" .
						"Accept: application/json\r\n"
			)
		);
		$context  = stream_context_create( $options );
		$result = file_get_contents( $url, false, $context );
		//$response = json_encode( $result );
		//echo $response;
		echo $result;
	}


	function proc_opensips_dr_gw_status(){
		
		$gwid = $_REQUEST['gwid'];
		//$gwid = 'gw-stend-12.84';
		
		$url = "http://127.0.0.1:8888/mi";
		$data = array(
		  'jsonrpc' => '2.0', 
		  'id'      => 1,
		  'method'  => 'dr_gw_status',
		  'params' => array('gw_id' => $gwid)
		);
		$options = array(
		  'http' => array(
			'method'  => 'POST',
			'content' => json_encode( $data ),
			'header'=>  "Content-Type: application/json\r\n" .
						"Accept: application/json\r\n"
			)
		);
		$context  = stream_context_create( $options );
		$result = file_get_contents( $url, false, $context );
		echo json_encode($result);

	}

	
//curl -X POST localhost:8888/mi -H 'Content-Type: application/json' -d '{"jsonrpc": "2.0", "id": "1", "method": "dr_gw_status", "gw_id": "gw-stend-12.84"}'	
//curl -X POST localhost:8888/mi -H 'Content-Type: application/json' -d '{"jsonrpc": "2.0", "id": "1", "method": "dr_gw_status", "params": {"gw_id": "gw-stend-12.84"} }'	
	
//opensips-cli -x mi dr_gw_status gw_id=gw-stend-12.81


	

	function proc_gateways_new_prefix() {
		global $session, $database, $logger;

		$px_start = empty($_REQUEST['px_start']) ? null : $_REQUEST['px_start'];

		$q = <<<EOS
		execute procedure GATEWAYS_NEW_PREFIX(
			:PX_START
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":PX_START",$px_start);

		$q->execute();
		$result = $q->fetchAll();

		echo json_encode($result);
	}


	function proc_get_rule_type() {
		global $database, $session, $logger;

		$q = <<<EOS
		select
			rule_type_id,
			rule_type_name
		from dr_rule_type order by rule_type_id;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		$res[0] = array('rule_type_id' => null); 

		foreach($result as $key => $row){
		$res[$key] = array(
			'rule_type_id' => $row['rule_type_id'],
			'rule_type_name' => $row['rule_type_name']
		);
		}
		
		echo json_encode($res);
	}



	
};

$process = new Process;

?>