
$(document).ready( function () {
	

	$( function() {

		$( "#f_ACC_created_D1" ).datepicker({changeMonth: true, changeYear: true, showOtherMonths: true, selectOtherMonths: true});
		$( "#f_ACC_created_D1" ).datepicker( "option", "dateFormat", "dd.mm.yy" );
		
		$( "#f_ACC_created_D2" ).datepicker({changeMonth: true, changeYear: true, showOtherMonths: true, selectOtherMonths: true});
		$( "#f_ACC_created_D2" ).datepicker( "option", "dateFormat", "dd.mm.yy" );
		
		$( "#f_MC_created_D1" ).datepicker({changeMonth: true, changeYear: true, showOtherMonths: true, selectOtherMonths: true});
		$( "#f_MC_created_D1" ).datepicker( "option", "dateFormat", "dd.mm.yy" );
		
		$( "#f_MC_created_D2" ).datepicker({changeMonth: true, changeYear: true, showOtherMonths: true, selectOtherMonths: true});
		$( "#f_MC_created_D2" ).datepicker( "option", "dateFormat", "dd.mm.yy" );

	});

	$(".24h").inputmask({
	alias: "datetime",
	inputFormat: "HH:MM:ss"
	});

	doCDR_ACC_Find(1);
	
	doCDR_MC_Find(1);

	//replaceChecks();
	
});


function get_cdr_acc_page(create_D1,create_T1,create_D2,create_T2,method,recpage,viewpage){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_cdr_acc_page',
			create_D1,
			create_T1,
			create_D2,
			create_T2,
			method: method,
			recpage: recpage,
			viewpage: viewpage
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			if(data[0]['id'] != null){
			$.each(data, function (index, value) {
				addRowCDR("i",value);
			});
			}
			result = data;
		},
		error:function(){
			alert('error: get_cdr_acc_page');
		}
	});
	
	return result;
}

function doCDR_ACC_Find(viewpage){
	var recpage = document.getElementById('f_ACC_recpage').value;
	var method = document.getElementById('f_CDR_ACC_method').value;
	document.getElementById('CDR_ACC_TableRecords').innerHTML = 'records: 0';
	
	var create_D1 = document.getElementById('f_ACC_created_D1').value;
	var create_T1 = document.getElementById('f_ACC_created_T1').value;
	var create_D2 = document.getElementById('f_ACC_created_D2').value;
	var create_T2 = document.getElementById('f_ACC_created_T2').value;
	//alert(create_D1+' '+create_T1+' '+create_D2+' '+create_T2);

	var tab = $('table[id=CDR_ACC_Table]')[0];
	$(tab).find("tr:gt(0)").remove();
	var res = get_cdr_acc_page(create_D1,create_T1,create_D2,create_T2,method,recpage,viewpage);

	// page numbers line
	var pagecount = res['0']['pagecount'];
	if(pagecount>=0){
		var tab = $('table[id=CDR_ACC_TablePageLine]')[0];
		var td = $(tab).find("tr:eq(0)").children("td")[0];
		td.innerHTML = '';
		for (var i = 1; i <= pagecount; i++) {
			var active_num = (viewpage == i) ? 'border: 1px solid #7484a0; border-radius: 2px;' : '';
			td.innerHTML += '<input type="button" class="popup-pagenum" value="'+i+'" style="margin-left:1px;z-index: 99999;cursor:pointer;'+active_num+'" onclick="doCDR_ACC_Find('+i+');">';
		}
	}
	//replaceChecks();
}


function addRowCDR(mode,value){
	var tab = document.getElementById('CDR_ACC_Table');

	if(!value || value==null){
		value = {
			"id": "", 
			"method": "", 
			"from_tag": "", 
			"to_tag": "", 
			"callid": "", 
			"sip_code": "", 
			"sip_reason": "", 
			"time_cmpl": "", 
			"duration": "", 
			"ms_duration": "", 
			"setuptime": "", 
			"created": "", 
			"src_ip": "", 
			"dst_ip": "", 
			"peer_name": "",
			"dest_name": "", 
			"dest_addr": "" 
		};
	}

	//var row_idx = $('tr[type=cdr_acc_row]').length + 1;
	var row_mode = mode;
	var row_idx = 1;
	$('tr[type=cdr_acc_row]').each(function() { 
		var idx = Number($('td:eq(0)',this).text()) + 1;
		if( idx > row_idx ) row_idx = idx;
	});

	document.getElementById('CDR_ACC_TableRecords').innerHTML = 'records: '+ row_idx;

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","cdr_acc_row");
	//tr.setAttribute("row_idx",row_idx);
	
	$(tr).dblclick(function(){
		viewTableRowDetail(this,row_idx);
	});


	var td = document.createElement("td");
	td.setAttribute("row_idx",row_idx);
	td.style.display = "none";
	td.innerHTML =	row_idx;
	tr.appendChild(td);
	var td = document.createElement("td");
	td.setAttribute("row_mode",row_mode);
	td.style.display = "none";
	td.innerHTML =	row_mode;
	tr.appendChild(td);
	
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["id"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["method"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["from_tag"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["to_tag"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["callid"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["sip_code"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["sip_reason"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["time_cmpl"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["duration"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["ms_duration"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["setuptime"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["created"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["src_ip"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["dst_ip"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["peer_name"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["dest_name"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["dest_addr"];
	tr.appendChild(td);


	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"viewTableRowDetail($(this).parent().parent()[0],"+row_idx+");\" title=\"View detail\" src=\"../inc/img/view.png\">";
	tr.appendChild(td);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
    });	

	if(mode == "a") $(tr).children('td').css("backgroundColor","#c4ffc4");
	
}


//-----------------------------------------------------------------------------------------------------
// CDR MISSED_CALLS
//-----------------------------------------------------------------------------------------------------

function get_cdr_mc_page(create_D1,create_T1,create_D2,create_T2,method,recpage,viewpage){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_cdr_mc_page',
			create_D1,
			create_T1,
			create_D2,
			create_T2,
			method: method,
			recpage: recpage,
			viewpage: viewpage
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			if(data[0]['id'] != null){
			$.each(data, function (index, value) {
				addRowCDR_MC("i",value);
			});
			}
			result = data;
		},
		error:function(){
			alert('error: get_cdr_mc_page');
		}
	});
	
	return result;
}

function doCDR_MC_Find(viewpage){
	var recpage = document.getElementById('f_MC_recpage').value;
	var method = document.getElementById('f_CDR_MC_method').value;
	document.getElementById('CDR_MC_TableRecords').innerHTML = 'records: 0';
	//alert(recpage);

	var create_D1 = document.getElementById('f_MC_created_D1').value;
	var create_T1 = document.getElementById('f_MC_created_T1').value;
	var create_D2 = document.getElementById('f_MC_created_D2').value;
	var create_T2 = document.getElementById('f_MC_created_T2').value;
	//alert(create_D1+' '+create_T1+' '+create_D2+' '+create_T2);

	var tab = $('table[id=CDR_MC_Table]')[0];
	$(tab).find("tr:gt(0)").remove();
	var res = get_cdr_mc_page(create_D1,create_T1,create_D2,create_T2,method,recpage,viewpage);

	// page numbers line
	var pagecount = res['0']['pagecount'];
	if(pagecount>=0){
		var tab = $('table[id=CDR_MC_TablePageLine]')[0];
		var td = $(tab).find("tr:eq(0)").children("td")[0];
		td.innerHTML = '';
		for (var i = 1; i <= pagecount; i++) {
			var active_num = (viewpage == i) ? 'border: 1px solid #7484a0; border-radius: 2px;' : '';
			td.innerHTML += '<input type="button" class="popup-pagenum" value="'+i+'" style="margin-left:1px;z-index: 99999;cursor:pointer;'+active_num+'" onclick="doCDR_MC_Find('+i+');">';
		}
	}
}


function addRowCDR_MC(mode,value){
	var tab = document.getElementById('CDR_MC_Table');

	if(!value || value==null){
		value = {
			"id": "", 
			"method": "", 
			"from_tag": "", 
			"to_tag": "", 
			"callid": "", 
			"sip_code": "", 
			"sip_reason": "", 
			"time_cmpl": "", 
			"setuptime": "", 
			"created": "", 
			"src_ip": "", 
			"dst_ip": "", 
			"peer_name": "", 
			"dest_name": "", 
			"dest_addr": ""
		};
	}
		
	//var row_idx = $('tr[type=cdr_missed_calls_row]').length + 1;
	var row_mode = mode;
	var row_idx = 1;
	$('tr[type=cdr_missed_calls_row]').each(function() { 
		var idx = Number($('td:eq(0)',this).text()) + 1;
		if( idx > row_idx ) row_idx = idx;
	});

	document.getElementById('CDR_MC_TableRecords').innerHTML = 'records: '+ row_idx;

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","cdr_missed_calls_row");
	//tr.setAttribute("row_idx",row_idx);

	$(tr).dblclick(function(){
		viewTableRowDetail(this,row_idx);
	});

	var td = document.createElement("td");
	td.setAttribute("row_idx",row_idx);
	td.style.display = "none";
	td.innerHTML =	row_idx;
	tr.appendChild(td);
	var td = document.createElement("td");
	td.setAttribute("row_mode",row_mode);
	td.style.display = "none";
	td.innerHTML =	row_mode;
	tr.appendChild(td);
	
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["id"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["method"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["from_tag"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["to_tag"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["callid"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["sip_code"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["sip_reason"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["time_cmpl"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["setuptime"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["created"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["src_ip"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["dst_ip"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["peer_name"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["dest_name"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["dest_addr"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"viewTableRowDetail($(this).parent().parent()[0],"+row_idx+");\" title=\"View detail\" src=\"../inc/img/view.png\">";
	tr.appendChild(td);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
    });	

	if(mode == "a") $(tr).children('td').css("backgroundColor","#c4ffc4");
	
}

function doCDR_ACC_Reset(){
	document.getElementById('f_ACC_created_D1').value = '';
	document.getElementById('f_ACC_created_T1').value = '';
	document.getElementById('f_ACC_created_D2').value = '';
	document.getElementById('f_ACC_created_T2').value = '';
	document.getElementById('f_CDR_ACC_method').value = '';
	doCDR_ACC_Find(1);
}

function doCDR_MC_Reset(){
	document.getElementById('f_MC_created_D1').value = '';
	document.getElementById('f_MC_created_T1').value = '';
	document.getElementById('f_MC_created_D2').value = '';
	document.getElementById('f_MC_created_T2').value = '';
	document.getElementById('f_CDR_MC_method').value = '';
	doCDR_MC_Find(1);
}


function viewTableRowDetail(obj,row_idx){

	var tabset = "";
	var tab = $(obj).parent()[0];

	var tds = $('td',obj);
	$(tds).each(function(idx) { 
		var pname = $(tab).find("tr:eq(0)").children("td")[idx].innerHTML;
		var pval = this.innerHTML;
		if(pname!='&nbsp;')
		tabset += '<tr><td>'+pname+'</td><td><input id="'+tab.id+'_'+pname+'" type="text" class="selectw200" value="'+pval+'"></td></tr>'
	});
	
	var tabview = document.getElementById(tab.id+'_View');
	tabview.innerHTML = tabset;
	
	$('#'+tab.id+'_Form').arcticmodal();
}

