$(document).ready( function () {
	//get_db_options();
	get_domain();

	doUserFind();
});

function get_db_options(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_db_options'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['option_name']);
			//$.each(data, function (index, value) {
			//	alert(value['option_name']+' '+value['int_value']);
			//});
			$.each(data, function (index, value) {
				addDBOptionTableRow(value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_db_options');
		}
	});
	
	return result;
}

function get_domain(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_domain'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			$.each(data, function (index, value) {
				addDomainTableRow(value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_db_options');
		}
	});
	
	return result;
}


function getInputClass(val){
	if(val == null){
		class_str = " \"inputTableCellNull inputTableCellNullHide inputTableCellNullChecked\" readonly ";
	} else {
		class_str = " \"inputTableCellNull inputTableCellNullHide inputTableCellNullUnchecked\" ";
	}
	return class_str;
}
function getCheckboxClass(val){
	if(val == null){
		class_str = " \"checkTableCellNull checkTableCellNullHide\" checked title=\"unset null\" ";
	} else {
		class_str = " \"checkTableCellNull checkTableCellNullHide\" title=\"set null\" ";
	}
	return class_str;
}
function getCellInnerHtml(row_id,field_name,field_value){
	var html_str = "";
	html_str =	''+field_value+'';
	html_str =	'<input row_id='+row_id+' col_id="'+field_name+'" type="text" class=' + getInputClass(field_value) + ' style="" value="' + field_value + '" \
	oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,50,this);" /> \
	<input type="checkbox" class=' + getCheckboxClass(field_value) + ' \
	onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />';
	return html_str;
}


function addDBOptionTableRow(value){
	var tab = $('table[id=tab_dboptions]')[0];
	
	var row_mode = "";
	if(!value || value==null){
		value = {
			"option_name": "", 
			"int_value": "", 
			"str_value": "", 
			"date_value": "", 
			"float_value": "", 
			"description": "", 
			"param_type": "", 
			"param_name": "" 
		};
		row_mode = "a";
	}

	var row_id = $('tr[type=optionrow]').length;

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","optionrow");
	tr.setAttribute("row_id",row_id);
	
	var td = document.createElement("td");
	td.style.display = "none";
	td.innerHTML =	row_id;
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.setAttribute("type","optioncell");
	td.setAttribute("row_id",row_id);
	td.id = "option_name_"+row_id;
	td.innerHTML =	'<input row_id='+row_id+' col_id="option_name" type="text" class="inputTableCell" value="' + value['option_name'] + '" oninput="debounceEdtDBOption(this)" />';
		/*var input = document.createElement("input");
		input.type = "text";
		input.className = "inputTableCell";
		input.setAttribute("row_id",row_id);
		input.setAttribute("col_id","option_name");
		input.value = value['option_name'];
		td.appendChild(input);*/
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="int_value" type="text" class="inputTableCell" value="' + value['int_value'] + '" oninput="debounceEdtDBOption(this)" />';

	//td.innerHTML =	'<input row_id='+row_id+' col_id="int_value" type="text" class=' + getInputClass(value['int_value']) + ' style="" value="' + value['int_value'] + '" \
	//oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,100,this);" /> \
	//<input type="checkbox" class=' + getCheckboxClass(value['int_value']) + ' title="set null" \
	//onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />';

	td.innerHTML = getCellInnerHtml(row_id,'int_value',value['int_value']);

	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
//	td.innerHTML =	'<input row_id='+row_id+' col_id="str_value" type="text" class="inputTableCellNull inputTableCellNullHide" style="" value="' + value['str_value'] + '" \
//	oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(function(){inputTableCellNullBlur(this);},200);" /> \
//	<input type="checkbox" class="checkTableCellNull checkTableCellNullHide" title="set null" onchange="checkTableCellNullSet(this);" />';

//	td.innerHTML =	'<input row_id='+row_id+' col_id="str_value" type="text" class="inputTableCellNull inputTableCellNullHide" style="" value="' + value['str_value'] + '" \
//	oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,100,this);" /> \
//	<input type="checkbox" class="checkTableCellNull checkTableCellNullHide" title="set null" \
//	onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />';

	//td.innerHTML =	'<input row_id='+row_id+' col_id="str_value" type="text" class=' + getInputClass(value['str_value']) + ' style="" value="' + value['str_value'] + '" \
	//oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,100,this);" /> \
	//<input type="checkbox" class=' + getCheckboxClass(value['str_value']) + ' title="set null" \
	//onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />';
	
	td.innerHTML = getCellInnerHtml(row_id,'str_value',value['str_value']);


	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="date_value" type="text" class="inputTableCell" value="' + value['date_value'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'date_value',value['date_value']);
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="float_value" type="text" class="inputTableCell" value="' + value['float_value'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'float_value',value['float_value']);
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="description" type="text" class="inputTableCell" value="' + value['description'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'description',value['description']);
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="param_type" type="text" class="inputTableCell" value="' + value['param_type'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'param_type',value['param_type']);
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="param_name" type="text" class="inputTableCell" value="' + value['param_name'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'param_name',value['param_name']);
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<img src="../inc/img/del.gif" style="width:1.2em;height:1.2em;text-align:center;vertical-align:middle;cursor:pointer;" title="delete option" onclick="delDBOptionTableRow(this.parent.parent)">';
	td.innerHTML =	'<img src="../inc/img/del.gif" style="width:1.2em;height:1.2em;text-align:center;vertical-align:middle;cursor:pointer;" title="delete option" onclick="delDBOptionTableRow(this.parentElement.parentElement)">';
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.id = "rowmode_"+row_id;
	td.innerHTML =	row_mode;
	tr.appendChild(td);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
    });	

	if(row_mode == "a") $(tr).children('td').children('input').css("backgroundColor","#c4ffc4");
}

function delDBOptionTableRow(obj){
	var row_id = obj.getAttribute('row_id');

	var row_mode_obj = $('td[id=rowmode_'+row_id+']',obj)[0];
	var row_mode = $('td[id=rowmode_'+row_id+']',obj)[0].innerHTML;
	if(row_mode == "a") obj.remove();

	if(row_mode == ""){
		row_mode_obj.innerHTML = "d";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "line-through");
		$('input[row_id='+row_id+']',obj).css("font-style", "italic");
		$('input[row_id='+row_id+']',obj).css("color", "#ff4444");
	}
	if(row_mode == "d"){
		row_mode_obj.innerHTML = "";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "none");
		$('input[row_id='+row_id+']',obj).css("font-style", "normal");
		$('input[row_id='+row_id+']',obj).css("color", "#333");
	}

	if(row_mode == "e"){
		row_mode_obj.innerHTML = "ed";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "line-through");
		$('input[row_id='+row_id+']',obj).css("font-style", "italic");
		$('input[row_id='+row_id+']',obj).css("color", "#ff4444");
	}
	if(row_mode == "ed"){
		row_mode_obj.innerHTML = "e";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "none");
		$('input[row_id='+row_id+']',obj).css("font-style", "normal");
		$('input[row_id='+row_id+']',obj).css("color", "#333");
	}


	
	/*
	if(row_mode.innerHTML == ""){
		row_mode.innerHTML = "d";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "line-through");
	} else {
		if(row_mode.innerHTML == "d"){
			row_mode.innerHTML = "";
			$('input[row_id='+row_id+']',obj).css("text-decoration", "none");
		}
	}
	*/
}


// дебонсинг события редактирования
function debounce(func, wait, immediate) {
	var timeout;
	return function() {
		var context = this, args = arguments;
		clearTimeout(timeout);
		timeout = setTimeout(function() {
			timeout = null;
			if (!immediate) func.apply(context, args);
		}, wait);
		if (immediate && !timeout) func.apply(context, args);
	};
}

var debounceEdtDBOption = debounce(function(obj){
	EdtDBOption(obj);
}, 250);

function EdtDBOption(obj){
	var row_obj = obj.parentElement.parentElement;
	var row_id = row_obj.getAttribute('row_id');
	//obj.style.backgroundColor = "#ff8080";
	var row_mode_obj = $('td[id=rowmode_'+row_id+']',row_obj)[0];
	var row_mode = $('td[id=rowmode_'+row_id+']',row_obj)[0].innerHTML;
	if(row_mode != "a") {
		$(row_obj).children('td').children('input').css("backgroundColor","#ffc4c4");
		if(row_mode == "d" || row_mode == "ed") row_mode_obj.innerHTML = "ed";
		else row_mode_obj.innerHTML = "e";
	}
}


var debounceEdtTableRow = debounce(function(obj){
	EdtTableRow(obj);
}, 250);

function EdtTableRow(obj){
	var row_obj = obj.parentElement.parentElement;
	var row_idx = row_obj.getAttribute('row_idx');
	var tab_obj = obj.parentElement.parentElement.parentElement;
	var tab_id = tab_obj.id;
	
	var row_mode_obj = $('td[id=' + tab_id + "_row_mode_" + row_idx + ']',row_obj)[0];
	var row_mode = $('td[id=' + tab_id + "_row_mode_" + row_idx + ']',row_obj)[0].innerHTML;
	if(row_mode != "a") {
		$(row_obj).children('td').children('input').css("backgroundColor","#ffc4c4");
		if(row_mode == "d" || row_mode == "ed") row_mode_obj.innerHTML = "ed";
		else row_mode_obj.innerHTML = "e";
	}
}



function onSaveClick(){
	/*
	$('tr[type=optionrow]').each(function( index ) {
		//alert(index);
		//var obj = $(this).children('td').children('input')
		//var option_name = obj[0].value;
		var row_id = $(this).attr('row_id');
		
		var option_name = $('input[col_id=option_name][row_id='+row_id+']','td', this)[0].value;
		var int_value = $('input[col_id=int_value][row_id='+row_id+']','td', this)[0].value;
		var str_value = $('input[col_id=str_value][row_id='+row_id+']','td', this)[0].value;
		var date_value = $('input[col_id=date_value][row_id='+row_id+']','td', this)[0].value;
		var float_value = $('input[col_id=float_value][row_id='+row_id+']','td', this)[0].value;
		var description = $('input[col_id=description][row_id='+row_id+']','td', this)[0].value;
		var param_type = $('input[col_id=param_type][row_id='+row_id+']','td', this)[0].value;
		var param_name = $('input[col_id=param_name][row_id='+row_id+']','td', this)[0].value;
		
		var rowmode = $('td[id=rowmode_'+row_id+']',this)[0].innerHTML;
		//if(rowmode != '') alert(rowmode+' '+option_name);


		if(!int_value || int_value==null || int_value=='null') int_value = "";
		//if(!str_value || str_value==null || str_value=='null') str_value = "";
		if(!date_value || date_value==null || date_value=='null') date_value = "";
		if(!float_value || float_value==null || float_value=='null') float_value = "";
		//if(!description || description==null || description=='null') description = "";
		if(!param_type || int_value==null || param_type=='null') param_type = "";
		if(!param_name || param_name==null || param_name=='null') param_name = "";

		//zz = option_name+", "+int_value+", "+str_value+", "+date_value+", "+float_value+", "+description+", "+param_type+", "+param_name+", "+rowmode;
		//alert(zz);
		
		save_db_options(option_name, int_value, str_value, date_value, float_value, description, param_type, param_name, rowmode);

	});
	*/
	
	// save domain
	var tab_id = "tab_Domain";
	var tab_rowtype = tab_id+'_row';
	$('tr[row_type='+tab_rowtype+']').each(function( index ) {

		var row_idx = $(this).attr('row_idx');
		var row_mode = $('td[id=' + tab_id + "_row_mode_" + row_idx+ ']',this)[0].innerHTML;
		
		var id = $('input[col_id='+tab_id+'id][row_idx='+tab_id + '_' + row_idx+']','td', this)[0].value;
		var domain = $('input[col_id='+tab_id+'domain][row_idx='+tab_id + '_' + row_idx+']','td', this)[0].value;
		var attrs = $('input[col_id='+tab_id+'attrs][row_idx='+tab_id + '_' + row_idx+']','td', this)[0].value;
		var last_modified = $('input[col_id='+tab_id+'last_modified][row_idx='+tab_id + '_' + row_idx+']','td', this)[0].value;
		//alert(id+' '+domain+' '+attrs+' '+last_modified+' '+row_mode);

		save_domain(id, domain, attrs, row_mode);
		
	});


	// save administrator
	$('tr[type=user_row]','table[id=AdminTable]').each(function() { 
		
		var row_idx = $('td:eq(0)',this).text();
		var mode = $('td:eq(1)',this).text();
		
		if(mode == "a" || mode == "e"){
			var user_id = $('td:eq(2)',this).text() == 'undefined' ? null : Number($('td:eq(2)',this).text());
			var user_pass = $('td:eq(3)',this).text();
			var user_name = $('td:eq(4)',this).text();
			var user_fio = $('td:eq(5)',this).text();

			save_user(user_id,user_name,user_pass,user_fio);
		}

		if(mode == "d"){
			var user_id = Number($('td:eq(2)',this).text());
			del_user(user_id);
		}
		
	});

}

function save_domain(id, domain, attrs, row_mode){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_domain',
			id: id,
			domain: domain,
			attrs: attrs,
			row_mode: row_mode
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_domain');
		}
	});
}

function save_user(user_id,user_name,user_pass,user_fio){
	//alert([user_id,user_name,user_pass,user_fio]);
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_user',
			user_id: user_id,
			user_name: user_name,
			user_pass: user_pass,
			user_fio: user_fio
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_user');
		}
	});
}

function del_user(user_id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_user',
			user_id: user_id
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: del_user');
		}
	});
}






function save_db_options(option_name, int_value, str_value, date_value, float_value, description, param_type, param_name, rowmode){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_db_options',
			option_name: option_name,
			int_value: int_value,
			str_value: str_value,
			date_value: date_value,
			float_value: float_value,
			description: description,
			param_type: param_type,
			param_name: param_name,
			rowmode: rowmode
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_db_options');
		}
	});
}



function inputTableCellNullFocus(obj){
	//$('input.inputTableCellNull').removeClass( "inputTableCellNullShow" ).addClass( "inputTableCellNullHide" );
	var ch = $(obj).next('[type=checkbox]')[0];
	$(obj).removeClass( "inputTableCellNullHide" ).addClass( "inputTableCellNullShow" );
	$(ch).removeClass( "checkTableCellNullHide" ).addClass( "checkTableCellNullShow" );
}

function inputTableCellNullBlur(obj){
	var ch = $(obj).next('[type=checkbox]')[0];
	var ac = document.activeElement;
	if( ac != ch ){
		$(obj).removeClass( "inputTableCellNullShow" ).addClass( "inputTableCellNullHide" );
		$(ch).removeClass( "checkTableCellNullShow" ).addClass( "checkTableCellNullHide" );
	}
}
function checkTableCellNullBlur(obj){
	var inp = $(obj).prev('input[type=text]')[0];
	var ac = document.activeElement;
	if( ac != inp ){
		$(inp).removeClass( "inputTableCellNullShow" ).addClass( "inputTableCellNullHide" );
		$(obj).removeClass( "checkTableCellNullShow" ).addClass( "checkTableCellNullHide" );
	}
}


function checkTableCellNullSet(obj){
	var inp = $(obj).prev('input[type=text]')[0];
	EdtDBOption(inp);
	if(obj.checked) {
		obj.setAttribute('title','unset null');
		inp.value = "null";
		inp.setAttribute("readonly","true");
		/*$(inp).css("background", "var(--grey-light)");
		$(inp).css("color", "var(--grey-light)");*/
		$(inp).removeClass( "inputTableCellNullUnchecked" ).addClass( "inputTableCellNullChecked" );
	} else {
		obj.setAttribute('title','set null');
		inp.value = "";
		inp.removeAttribute('readonly');
		/*$(inp).css("background", "#fff");
		$(inp).css("color", "var(--grey-dark)");
		inp.focus();*/
		$(inp).removeClass( "inputTableCellNullChecked" ).addClass( "inputTableCellNullUnchecked" );
	}
}


//------------------------------------------------------------------------------------------------------

function addDomainTableRow(value){
	var tab_id = "tab_Domain";
	var tab = $('table[id='+tab_id+']')[0];
	
	var row_mode = "";
	if(!value || value==null){
		value = {
			"id": "", 
			"domain": "", 
			"attrs": "", 
			"last_modified": "" 
		};
		row_mode = "a";
	}

	var tab_rowtype = tab_id+'_row';
	var row_idx = $('tr[row_type='+tab_rowtype+']').length;
	
	/*var row_act = mode;
	var row_idx = 1;
	$('tr[type=resourcerow]').each(function() { 
		var idx = Number($('td:eq(0)',this).text()) + 1;
		if( idx > row_idx ) row_idx = idx;
	});*/
	

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("row_type",tab_rowtype);
	tr.setAttribute("row_idx",row_idx);
	
	var td = document.createElement("td");
	td.style.display = "none";
	td.id = tab_id + "_row_idx_" + row_idx;
	td.innerHTML =	row_idx;
	tr.appendChild(td);
	
	var td = document.createElement("td");
	td.style.display = "none";
	td.id = tab_id + "_row_mode_" + row_idx;
	td.innerHTML =	row_mode;
	tr.appendChild(td);
	
	var td = document.createElement("td");
	td.style.display = "none";
	td.setAttribute("row_type",tab_rowtype);
	td.setAttribute("row_idx",row_idx);
	td.id = tab_id + "_id_" + row_idx;
	td.innerHTML =	'<input row_idx='+tab_id + '_' + row_idx+' col_id="'+tab_id+'id" type="text" class="inputTableCell" value="' + value['id'] + '" oninput="debounceEdtTableRow(this)" />';
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.setAttribute("row_type",tab_rowtype);
	td.setAttribute("row_idx",row_idx);
	td.id = tab_id + "_domain_" + row_idx;
	td.innerHTML =	'<input row_idx='+tab_id + '_' + row_idx+' col_id="'+tab_id+'domain" type="text" class="inputTableCell" value="' + value['domain'] + '" oninput="debounceEdtTableRow(this)" />';
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.setAttribute("row_type",tab_rowtype);
	td.setAttribute("row_idx",row_idx);
	td.id = tab_id + "_attrs_" + row_idx;
	td.innerHTML =	'<input row_idx='+tab_id + '_' + row_idx+' col_id="'+tab_id+'attrs" type="text" class="inputTableCell" value="' + value['attrs'] + '" oninput="debounceEdtTableRow(this)" />';
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.setAttribute("row_type",tab_rowtype);
	td.setAttribute("row_idx",row_idx);
	td.id = tab_id + "_last_modified_" + row_idx;
	td.innerHTML =	'<input row_idx='+tab_id + '_' + row_idx+' col_id="'+tab_id+'last_modified" type="text" class="inputTableCell" value="' + value['last_modified'] + '" readonly />';
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML =	'<img src="../inc/img/del.gif" style="width:1.2em;height:1.2em;text-align:center;vertical-align:middle;cursor:pointer;" title="Delete Domain" onclick="delDomainTableRow(this.parentElement.parentElement)">';
	tr.appendChild(td);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
    });	

	if(row_mode == "a") $(tr).children('td').children('input').css("backgroundColor","#c4ffc4");
	
	document.getElementById('DomainTableRecords').innerHTML = 'records: ' + eval(row_idx + 1);
}

function delDomainTableRow(obj){
	var tab_id = "tab_Domain";
	var row_idx = obj.getAttribute('row_idx');

	var tab_rowtype = tab_id+'_row';
	var row_count = $('tr[row_type='+tab_rowtype+']').length;

	var row_mode_obj = $('td[id=' + tab_id + '_row_mode_'+row_idx+']',obj)[0];
	var row_mode = $('td[id=' + tab_id + '_row_mode_'+row_idx+']',obj)[0].innerHTML;
	if(row_mode == "a") {
		obj.remove();
		document.getElementById('DomainTableRecords').innerHTML = 'records: ' + eval(row_count - 1);
	}

	if(row_mode == ""){
		row_mode_obj.innerHTML = "d";
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("text-decoration", "line-through");
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("font-style", "italic");
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("color", "#ff4444");
	}
	if(row_mode == "d"){
		row_mode_obj.innerHTML = "";
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("text-decoration", "none");
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("font-style", "normal");
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("color", "#333");
	}

	if(row_mode == "e"){
		row_mode_obj.innerHTML = "ed";
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("text-decoration", "line-through");
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("font-style", "italic");
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("color", "#ff4444");
	}
	if(row_mode == "ed"){
		row_mode_obj.innerHTML = "e";
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("text-decoration", "none");
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("font-style", "normal");
		$('input[row_idx=' + tab_id + '_' + row_idx + ']',obj).css("color", "#333");
	}
	
}	


// ---------------------------------------------------------------------------------------------
// Administrator
// ---------------------------------------------------------------------------------------------


function openAdministratorForm(mode, row_idx){
	
	document.getElementById('addAdministratorForm').setAttribute('mode',mode);
	$('input[id^="AdministratorForm_"]').val("");
	
	if(mode == 1){
	
		//checkSetValue('GateForm_state',0);
	
	}

	if(mode == 2){
		
		var tab = document.getElementById('AdminTable');
		var row = $("tr",tab).eq(row_idx);
		$('input[id="AdministratorForm_row_idx"]').val(row_idx);

		var cell = $("td:eq(4)", row).text();
		document.getElementById('AdministratorForm_user_name').value = cell;

		var cell = $("td:eq(5)", row).text();
		document.getElementById('AdministratorForm_user_fio').value = cell;

		var cell = $("td:eq(3)", row).text();
		document.getElementById('AdministratorForm_user_pass').value = cell;

	}
	
	$('#addAdministratorForm').arcticmodal();
}


function get_user(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_user'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			if(data[0]['user_id'] != null){
			$.each(data, function (index, value) {
				addRowUser("i",value);
			});
			}
			result = data;
		},
		error:function(){
			alert('error: get_user');
		}
	});
	
	return result;
}

function doUserFind(){

	var tab = $('table[id=AdminTable]')[0];
	$(tab).find("tr:gt(0)").remove();
	var res = get_user();

}

function addRowUser(mode,value){
	var tab = document.getElementById('AdminTable');

	if(!value || value==null){
		value = {
			"user_id": "", 
			"user_name": "", 
			"user_pass": "", 
			"user_fio": ""
		};
	}

	//var row_idx = $('tr[type=user_row]').length + 1;
	var row_mode = mode;
	var row_idx = 1;
	$('tr[type=user_row]').each(function() { 
		var idx = Number($('td:eq(0)',this).text()) + 1;
		if( idx > row_idx ) row_idx = idx;
	});


	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","user_row");
	
	var td = document.createElement("td");
	td.setAttribute("row_idx",row_idx);
	td.style.display = "none";
	td.innerHTML =	row_idx;
	tr.appendChild(td);
	var td = document.createElement("td");
	td.setAttribute("row_mode",row_mode);
	td.style.display = "none";
	td.innerHTML =	row_mode;
	tr.appendChild(td);
	
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.innerHTML = value["user_id"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	//td.innerHTML = value["user_pass"];
	if(mode=='i') td.innerHTML = "";
	if(mode=='a' || mode=='e') td.innerHTML = value["user_pass"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["user_name"];
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = value["user_fio"];
	tr.appendChild(td);


	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"openAdministratorForm(2,"+row_idx+");\" title=\"Edit Administrator\" src=\"../inc/img/edt.gif\">";
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.innerHTML = "<img class=\"imglink\" style=\"display:inline;float:right;\" onclick=\"delAdministrator(this);\" title=\"Delete Administrator\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
    });	

	if(mode == "a") $(tr).children('td').css("backgroundColor","#c4ffc4");
	
}

function delAdministrator(obj){
	
	obj = obj.parentElement.parentElement;
	var row_idx = $("td:eq(0)", obj).text();
	var row_mode = $("td:eq(1)", obj).text();
	//alert(row_idx+' '+row_mode);
	
	if(row_mode == 'a') { 
		obj.remove(); 
	}
	else { 
		if(row_mode != 'd') { 
			$("td:eq(1)", obj).attr('row_mode','d'); 
			$("td:eq(1)", obj).text('d'); 
			$('td:visible',obj).attr('style','text-decoration:line-through;font-style:italic; color:#ff4444;');
			$(obj).children('td').css("backgroundColor","#f5f5f5");
		}
		else { 
			$("td:eq(1)", obj).attr('row_mode','e'); 
			$("td:eq(1)", obj).text('e'); 
			$('td:visible',obj).attr('style','text-decoration:none;font-style:normal; color:#777;');
			$(obj).children('td').css("backgroundColor","#ffc4c4");
		}
	}

}

function addUser(){
	var tab = document.getElementById('AdminTable');
	var mode = document.getElementById('addAdministratorForm').getAttribute('mode');

	var value = {
		"user_id": document.getElementById('AdministratorForm_user_id').value, 
		"user_pass": document.getElementById('AdministratorForm_user_pass').value, 
		"user_name": document.getElementById('AdministratorForm_user_name').value, 
		"user_fio": document.getElementById('AdministratorForm_user_fio').value 
	};

	if(mode == 1){ // add
		addRowUser("a",value);
	}
	if(mode == 2){ // edt
		var row_idx = $('input[id="AdministratorForm_row_idx"]').val();
		edtRowUser(row_idx,value);
	}
	
	$('#addAdministratorForm').arcticmodal('close');
	replaceChecks();
}

function edtRowUser(row_idx,value){
		var tab = document.getElementById('AdminTable');
		var row = $("tr",tab).eq(row_idx);

		if($("td:eq(1)", row).text() != "a") $("td:eq(1)", row).text("e");

		$("td:eq(4)", row).text(value['user_name']);
		$("td:eq(5)", row).text(value['user_fio']);
		$("td:eq(3)", row).text(value['user_pass']);
		
		if($("td:eq(1)", row).text() != "a") $(row).children('td').css("backgroundColor","#ffc4c4");
}

